unit CF;
{ Copyright (c) 1998, Tim Ahrentlv}
interface

uses WinTypes, WinProcs, Dialogs;


const

// #define DBL_EXPORT(type_)	 type_ DBL_CDECL
// #define DBL_EXPORTVA(type_)	 type_ DBL_CDECL


DBL_MaxRecSize		      = 2000;	// Changed from 1000
DBL_MaxCompanyNameLen	= 30;	   // Changed from 15
DBL_MaxTableNameLen	   = 30;
DBL_MaxFieldNameLen	   = 30;    // Changed from 20
DBL_MaxUserIDLen	      = 10;
DBL_MaxNoOfKeys 	      = 40;    // Changed from 20
DBL_MaxFieldsPerKey	   = 20;    // Changed from 10
DBL_MaxSumFieldsPerKey	= 20;    // Changed from 10
DBL_MaxPassWordLen	   = 10;

Module_DB		         = 19;

// #define DEFINE_DBERR(xErrNo)	((((DBL_S32)(Module_DB) * $10000L + (DBL_S32)(xErrNo)) | $1000000L) | $4000000L)

// #define DBL_Err_TableNotFound	DEFINE_DBERR(1008)
// #define DBL_Err_RecordNotFound	DEFINE_DBERR(1008)
// #define DBL_Err_RecordExists	DEFINE_DBERR(1009)
// #define DBL_Err_KeyNotFound	DEFINE_DBERR(1007)

type
PVoid           = pointer;
DBL_U8          = char;
PDBL_U8         = ^DBL_U8;
DBL_U16         = word;
DBL_S16         = smallint;
DBL_U32         = cardinal;
DBL_S32         = longint;
PDBL_S32        = ^DBL_S32;
DBL_O32         = longint;

DBL_BOOL        = longbool;		   // (DBL_U32) Changed from DBL_S16
PDBL_BOOL       = ^DBL_BOOL;

DBL_DATE        = DBL_U32;	      // Changed from DBL_U16
PDBL_DATE       = ^DBL_DATE;

DBL_TIME        = DBL_U32;
PDBL_TIME       =^DBL_TIME;

PDBL_BCD         = ^DBL_BCD;
DBL_BCD = record
  Exp:  DBL_U8;
  Mant: array[0..8] of DBL_U8;
  Slack:array[0..1] of DBL_U8;
end;    // Changed from typedef struct { DBL_U8 Exp; DBL_U8 Mant[9];} DBL_BCD

DBL_HREC         = DWORD;
DBL_HTABLE       = DWORD;

PDBL_HREC        = ^DBL_HREC;
PDBL_HTABLE      = ^DBL_HTABLE;


DBL_pFuncExceptionHandler = procedure(ErrorCode:DBL_S32;IsFatal:DBL_BOOL) of object;
DBL_pFuncMessageShowHandler= procedure(aMessage:PDBL_U8;MessageType:DBL_U32;ErrorCode:DBL_S32) of object;

const

DBL_Class_Normal	   = 0;
DBL_Class_FlowField	= 1;
DBL_Class_FlowFilter	= 2;


DBL_VERSION		      = 7;

DBL_LockWait	      = 0;		   // DBL_LockTable() Option
DBL_LockNoWait	      = 1;		   // DBL_LockTable() Option

// New features
C_DBL_DirTableNo        = 2000000001;
F_DBL_DR_ObjType        = 1;

C_DBL_OT_TableData      = 0;
C_DBL_OT_TableDesc      = 1;
C_DBL_OT_Form		      = 2;
C_DBL_OT_Report		   = 3;
C_DBL_OT_Dataport       = 4;
C_DBL_OT_Codeunit       = 5;
C_DBL_OT_System         = 10;

F_DBL_DR_CompanyName    = 2;
F_DBL_DR_ObjNo          = 3;
F_DBL_DR_ObjName        = 4;
F_DBL_DR_Modified       = 5;
F_DBL_DR_Compiled       = 6;
F_DBL_DR_Blob           = 7;
F_DBL_DR_BlobSize       = 8;
F_DBL_DR_DBMTableNo     = 9;
F_DBL_DR_StampDate      = 10;
F_DBL_DR_StampTime      = 11;
F_DBL_DR_VersionList    = 12;

C_DBL_UserTableNo       = 2000000002;
F_DBL_UR_UserID         = 1;
F_DBL_UR_Password       = 2;
F_DBL_UR_Name           = 3;
F_DBL_UR_ValidUntil     = 4;

C_DBL_MemberOfTableNo	= 2000000003;
F_DBL_MR_UserID         = 1;
F_DBL_MR_UserName       = 2;
F_DBL_MR_GroupID        = 3;
F_DBL_MR_GroupName      = 4;
F_DBL_MR_CompanyName    = 5;

C_DBL_UserGroupTableNo	= 2000000004;
F_DBL_UG_GroupID        = 1;
F_DBL_UG_Name           = 2;

C_DBL_PermissionTableNo = 2000000005;
F_DBL_PR_GroupID        = 1;
F_DBL_PR_GroupName      = 2;
F_DBL_PR_ObjType        = 3;

//C_DBL_OT_TableData      = 0;
//C_DBL_OT_TableDesc      = 1;
//C_DBL_OT_Form           = 2;
//C_DBL_OT_Report         = 3;
//C_DBL_OT_Dataport       = 4;
//C_DBL_OT_Codeunit       = 5;
//C_DBL_OT_System         = 10;
F_DBL_PR_ObjNo          = 4;
F_DBL_PR_ObjName        = 5;
F_DBL_PR_Read           = 6;
F_DBL_PR_Insert         = 7;
F_DBL_PR_Modify         = 8;
F_DBL_PR_Delete         = 9;
F_DBL_PR_Execute        = 10;

C_DBL_CompanyTableNo    = 2000000006;
F_DBL_CR_Name           = 1;

C_DBL_DATETableNo       = 2000000007;
F_DBL_DT_PeriodType     = 1;
C_DBL_DT_Date           = 0;
C_DBL_DT_Week           = 1;
C_DBL_DT_Month          = 2;
C_DBL_DT_Quarter        = 3;
C_DBL_DT_Year           = 4;
F_DBL_DT_PeriodStart    = 2;
F_DBL_DT_PeriodEnd      = 3;

C_DBL_ConnTableNo       = 2000000009;
F_DBL_CR_ConnectionID   = 1;
F_DBL_CR_UserID         = 2;
F_DBL_CR_MySession      = 3;
F_DBL_CR_UserName       = 4;
F_DBL_CR_LoginTime      = 5;
F_DBL_CR_LoginDate      = 6;
F_DBL_CR_CacheReads     = 7;
F_DBL_CR_DiskReads      = 8;
F_DBL_CR_DiskWrites     = 9;
F_DBL_CR_RecsFound      = 10;
F_DBL_CR_RecsScanned    = 11;
F_DBL_CR_RecsInserted   = 12;
F_DBL_CR_RecsDeleted    = 13;
F_DBL_CR_RecsModified   = 14;
F_DBL_CR_SumIntervals   = 15;

C_DBL_DatabaseFilesTableNo = 2000000010;
F_DBL_DF_No             = 1;
F_DBL_DF_OSFileName     = 2;
F_DBL_DF_SizeInKb       = 3;
F_DBL_DF_TotalReads     = 4;
F_DBL_DF_MeanReadTimeMS = 5;
F_DBL_DF_ReadsInQueue   = 6;
F_DBL_DF_TotalWrites    = 7;
F_DBL_DF_MeanWriteTimeMS= 8;
F_DBL_DF_WritesInQueue  = 9;
F_DBL_DF_DiskLoadInPct  = 10;

C_DBL_DRIVETableNo	   = 2000000020;
F_DBL_DRT_Drive		   = 1;
F_DBL_DRT_Removable		= 2;
F_DBL_DRT_SizeInKb		= 3;
F_DBL_DRT_FreeInKb		= 4;

C_DBL_FILETableNo	      = 2000000022;
F_DBL_FT_Path 		      = 1;
F_DBL_FT_IsFile		   = 2;
F_DBL_FT_Name 		      = 3;
F_DBL_FT_Size 		      = 4;
F_DBL_FT_Date 		      = 5;
F_DBL_FT_Time 		      = 6;
F_DBL_FT_Data 		      = 7;

C_DBL_MoniTableNo	      = 2000000024;
F_DBL_MT_CallNo		   = 1;
F_DBL_MT_FuncType		   = 2;
F_DBL_MT_ParameterSeqNo = 3;
F_DBL_MT_Parameter	   = 4;
C_DBL_TableParmNo	      = 1;
C_DBL_SearchRecParmNo   = 2;
C_DBL_SearchIndexParmNo = 3;
C_DBL_FilterParmNo	   = 4;
C_DBL_SearchStrParmNo	= 5;
C_DBL_SearchResultParmNo = 6;
C_DBL_FoundRecParmNo    = 7;
C_DBL_RealsParmNo       = 8;
C_DBL_TimeUsedParmNo	   = 9;
C_DBL_RecsScannedParmNo	= 10;
C_DBL_SumIntervalsParmNo= 11;
C_DBL_RecsDeletedParmNo = 12;
C_DBL_DiskReadParmNo    = 13;
C_DBL_DiskWriteParmNo   = 14;
C_DBL_RecordParmNo		= 15;
C_DBL_WaitParmNo		   = 16;
C_DBL_SumFieldsParmNo	= 17;
C_DBL_BlobFieldParmNo	= 18;
C_DBL_CommitParmNo		= 19;
C_DBL_UserIDParmNo		= 20;
C_DBL_FileNameParmNo	   = 21;
F_DBL_MT_Number		   = 5;
F_DBL_MT_Data 		      = 6;

C_DBL_S32TableNo        = 2000000026;
F_DBL_DT_S32            = 1;

C_DBL_TITableNo         = 2000000028;
F_DBL_TI_CompanyName    = 1;
F_DBL_TI_ObjNo          = 2;
F_DBL_TI_ObjName        = 3;
F_DBL_TI_NoOfRecs       = 4;
F_DBL_TI_RecSize        = 5;
F_DBL_TI_TableSizeInKb  = 6;
F_DBL_TI_Utilization    = 7;

C_DBL_SysObjTableNo     = 2000000029;
F_DBL_SYO_ObjType       = F_DBL_DR_ObjType;
//C_DBL_OT_TableData      = 0;
//C_DBL_OT_TableDesc      = 1;
//C_DBL_OT_Form           = 2;
//C_DBL_OT_Report         = 3;
//C_DBL_OT_Dataport       = 4;
//C_DBL_OT_Codeunit       = 5;
//C_DBL_OT_System         = 10;
F_DBL_SYO_ObjNo         = F_DBL_DR_ObjNo;
F_DBL_SYO_ObjName       = F_DBL_DR_ObjName;

C_DBL_PERFTableNo	      = 2000000037;
F_DBL_PERF_No 		      = 1;
F_DBL_PERF_Name		   = 2;
F_DBL_PERF_Value		   = 3;
F_DBL_PERF_Unit		   = 4;

C_DBL_AllObjTableNo     = 2000000038;
F_DBL_ALLO_ObjType      = F_DBL_DR_ObjType;
F_DBL_ALLO_ObjNo        = F_DBL_DR_ObjNo;
F_DBL_ALLO_ObjName      = F_DBL_DR_ObjName;

C_DBL_PRINTERTableNo    = 2000000039;
F_DBL_PDR_ID            = 1;
F_DBL_PDR_Name          = 2;
F_DBL_PDR_Driver        = 3;
F_DBL_PDR_Device        = 4;

C_DBL_LicenseTableNo    = 2000000040;
F_DBL_LIC_LineNo        = 1;
F_DBL_LIC_Text          = 2;

C_DBL_AFIELDTableNo     = 2000000041;
F_DBL_AFIELDT_TableNo   = 1;
F_DBL_AFIELDT_No        = 2;
F_DBL_AFIELDT_TableName = 3;
F_DBL_AFIELDT_FieldName = 4;
F_DBL_AFIELDT_Type      = 5;
F_DBL_AFIELDT_Len       = 6;
F_DBL_AFIELDT_Class     = 7;
F_DBL_AFIELDT_Enabled   = 8;
F_DBL_AFIELDT_TypeName  = 9;


DBL_Type_STR		      = (45  * $100);
DBL_Type_DATE		      = (46  * $100);
DBL_Type_TIME		      = (46  * $100 + 1);
DBL_Type_BLOB		      = (132 * $100 + 2);
DBL_Type_BOOL		      = (133 * $100);
DBL_Type_S16		      = (134 * $100);
DBL_Type_S32		      = (135 * $100);
DBL_Type_U8		         = (136 * $100);
DBL_Type_ALPHA		      = (137 * $100);
DBL_Type_O32		      = (139 * $100);
DBL_Type_BCD		      = (50  * $100);

DBL_Msg_Critical	      = $002010;
DBL_Msg_Warning 	      = $002030;

ID_DBL_ALLOW            = 1;
ID_DBL_GETVERSION       = 2;
ID_DBL_INIT             = 3;
ID_DBL_EXIT             = 4;
ID_DBL_CONNECTSERVER    = 5;
ID_DBL_DISCONNECTSERVER = 6;
ID_DBL_OPENDATABASE     = 7;
ID_DBL_CLOSEDATABASE    = 8;
ID_DBL_OPENCOMPANY      = 9;
ID_DBL_CLOSECOMPANY     = 10;
ID_DBL_NEXTTABLE	      = 11;
ID_DBL_OPENTABLE	      = 12;
ID_DBL_TABLENAME	      = 13;
ID_DBL_CLOSETABLE	      = 14;
ID_DBL_LOCKTABLE	      = 15;
ID_DBL_FINDREC		      = 16;
ID_DBL_NEXTREC		      = 17;
ID_DBL_INSERTREC	      = 18;
ID_DBL_DELETEREC	      = 19;
ID_DBL_MODIFYREC	      = 20;
ID_DBL_RECCOUNT 	      = 21;
ID_DBL_INITREC		      = 22;
ID_DBL_CALCFIELDS	      = 23;
ID_DBL_CALCSUMS 	      = 24;
ID_DBL_KEYCOUNT 	      = 25;
ID_DBL_NEXTKEY		      = 26;
ID_DBL_KEYSUMFIELDS     = 27;
ID_DBL_SETCURRENTKEY	   = 28;
ID_DBL_GETCURRENTKEY	   = 29;
ID_DBL_SETFILTER	      = 30;
ID_DBL_GETFILTER	      = 31;
ID_DBL_SETRANGE 	      = 32;
ID_DBL_GETRANGE 	      = 33;
ID_DBL_FIELDCOUNT	      = 34;
ID_DBL_NEXTFIELD	      = 35;
ID_DBL_FIELDTYPE	      = 36;
ID_DBL_FIELDSIZE	      = 37;
ID_DBL_FIELDNAME	      = 38;
ID_DBL_FIELDOPTIONSTR   = 39;
ID_DBL_FIELDCLASS       = 40;
ID_DBL_ASSIGNFIELD	   = 41;
ID_DBL_GETFIELDDATAADDR = 42;
ID_DBL_GETFIELDDATASIZE = 43;
ID_DBL_GETFIELDDATA     = 44;
ID_DBL_SELECTLATESTVERSION = 45;
ID_DBL_BWT              = 46;
ID_DBL_EWT              = 47;
ID_DBL_AWT              = 48;
ID_DBL_USERID           = 49;
ID_DBL_COMPANYNAME      = 50;
ID_DBL_USERCOUNT        = 51;
ID_DBL_LOGIN            = 52;
ID_DBL_FIELD_2_STR      = 53;
ID_DBL_BCD_2_STR	      = 54;
ID_DBL_STR_2_BCD	      = 55;
ID_DBL_YMD_2_DATE	      = 56;
ID_DBL_DATE_2_YMD	      = 57;
ID_DBL_HMST_2_TIME      = 58;
ID_DBL_TIME_2_HMST      = 59;
ID_DBL_ALPHA_2_STR      = 60;
ID_DBL_STR_2_ALPHA      = 61;
ID_DBL_NEXTCOMPANY      = 62;
ID_DBL_TABLENO          = 63;
ID_DBL_FIELDNO          = 64;
ID_DBL_ALLOCREC         = 65;
ID_DBL_FREEREC          = 66;
ID_DBL_SETEXCEPTIONHANDLER = 67;
ID_DBL_GETDATABASENAME  = 68;
ID_DBL_COPYREC          = 69;
ID_DBL_CMPREC           = 70;
ID_DBL_SETMESSAGESHOWHANDLER = 71;
ID_DBL_GETLASTERRORCODE = 72;
ID_DBL_CHECKLICENSEFILE = 73;
ID_DBL_FIELDDATAOFFSET  = 74;
ID_DBL_STR_2_DATE       = 75;
ID_DBL_DATE_2_STR       = 76;
ID_DBL_STR_2_TIME       = 77;
ID_DBL_TIME_2_STR       = 78;
ID_DBL_RELEASEALLOBJECTS   = 79;
ID_DBL_OPENTEMPORARYTABLE  = 80;

// function interface
procedure DBL_Exit; cdecl;
function  DBL_Init:DBL_S32; cdecl;
procedure DBL_Allow(ErrorCode:DBL_S32); cdecl;
function  DBL_GetVersion:DBL_S32; cdecl;
procedure DBL_ConnectServer(ServerName:PDBL_U8; NetType:PDBL_U8); cdecl;
procedure DBL_DisconnectServer; cdecl;
procedure DBL_OpenDatabase (DatabaseName:PDBL_U8; CacheSize:DBL_S32; UseCommitCache:DBL_BOOL ); cdecl;
procedure DBL_CloseDatabase; cdecl;
function  DBL_NextCompany(CompanyName:PDBL_U8):PDBL_U8; cdecl;
procedure DBL_OpenCompany(CompanyName:PDBL_U8); cdecl;
procedure DBL_CloseCompany; cdecl;
function  DBL_NextTable(TableNo:DBL_S32):DBL_S32; cdecl;
function  DBL_OpenTable(hTablePtr:PDBL_HTABLE; TableNo:DBL_S32):DBL_BOOL; cdecl;
function  DBL_TableName(hTable:DBL_HTABLE):PDBL_U8; cdecl;
function  DBL_TableNo(TableName:PDBL_U8):DBL_S32; cdecl;
procedure DBL_CloseTable(hTable:DBL_HTABLE); cdecl;
procedure DBL_LockTable(hTable:DBL_HTABLE;Mode:DBL_U32); cdecl;
function  DBL_AllocRec(hTable:DBL_HTABLE):DBL_HREC; cdecl;
procedure DBL_FreeRec(Rec:DBL_HREC); cdecl;
function  DBL_FindRec(hTable:DBL_HTABLE;Rec:DBL_HREC;SearchMethod:PDBL_U8):DBL_BOOL; cdecl;
function  DBL_NextRec(hTable:DBL_HTABLE ;Rec:DBL_HREC;Step:DBL_S16):DBL_S16; cdecl;
function  DBL_InsertRec(hTable:DBL_HTABLE;Rec:DBL_HREC):DBL_BOOL; cdecl;
function  DBL_DeleteRec(hTable:DBL_HTABLE;Rec:DBL_HREC):DBL_BOOL; cdecl;
function  DBL_ModifyRec(hTable:DBL_HTABLE;Rec:DBL_HREC):DBL_BOOL; cdecl;
function  DBL_RecCount(hTable:DBL_HTABLE):DBL_S32; cdecl;
procedure DBL_InitRec(hTable:DBL_HTABLE;Rec:DBL_HREC); cdecl;
procedure DBL_CalcFields(hTable:DBL_HTABLE;Rec:DBL_HREC;FieldList:PDBL_S32); cdecl;
procedure DBL_CalcSums(hTable:DBL_HTABLE;Rec:DBL_HREC;FieldList:PDBL_S32); cdecl;
function  DBL_KeyCount(hTable:DBL_HTABLE):DBL_S16; cdecl;
function  DBL_NextKey(hTable:DBL_HTABLE;Key:PDBL_S32):PDBL_S32; cdecl;
function  DBL_KeySumFields(hTable:DBL_HTABLE;Key:PDBL_S32):PDBL_S32; cdecl;
function  DBL_SetCurrentKey(hTable:DBL_HTABLE;Key:PDBL_S32):DBL_BOOL; cdecl;
function  DBL_GetCurrentKey(hTable:DBL_HTABLE):PDBL_S32; cdecl;
procedure DBL_SetFilter(hTable:DBL_HTABLE;FieldNo:DBL_S32;FilterStr:PDBL_U8{, void *ValuePtr1, ...}); cdecl;
procedure DBL_GetFilter(hTable:DBL_HTABLE;FieldNo:DBL_S32;FilterStr:PDBL_U8;FilterStrSize:DBL_S16); cdecl;
procedure DBL_SetRange(hTable:DBL_HTABLE;FieldNo:DBL_S32;MinValue,MaxValue:PVoid); cdecl;
procedure DBL_GetRange(hTable:DBL_HTABLE;FieldNo:DBL_S32;MinValue,MaxValue:PVoid); cdecl;
function  DBL_FieldCount(hTable:DBL_HTABLE):DBL_S16; cdecl;
function  DBL_NextField(hTable:DBL_HTABLE;FieldNo:DBL_S32):DBL_S32; cdecl;
function  DBL_FieldType(hTable:DBL_HTABLE;FieldNo:DBL_S32):DBL_U16; cdecl;
function  DBL_FieldSize(hTable:DBL_HTABLE;FieldNo:DBL_S32):DBL_S16; cdecl;
function  DBL_FieldNo(hTable:DBL_HTABLE;FieldName:PDBL_U8):DBL_S32; cdecl;
function  DBL_FieldName(hTable:DBL_HTABLE;FieldNo:DBL_S32):PDBL_U8; cdecl;
function  DBL_FieldOptionStr(hTable:DBL_HTABLE;FieldNo:DBL_S32):PDBL_U8; cdecl;
function  DBL_FieldClass(hTable:DBL_HTABLE;FieldNo:DBL_S32):DBL_S16; cdecl;
procedure DBL_AssignField(hTable:DBL_HTABLE;hRec:DBL_HREC;FieldNo:DBL_S32;FType:DBL_U16;Data:PVoid;DataSize:DBL_S32);cdecl;
function  DBL_GetFieldDataAddr(hTable:DBL_HTABLE;hRec:DBL_HREC;FieldNo:DBL_S32):PVoid; cdecl;
function  DBL_GetFieldDataSize(hTable:DBL_HTABLE;FieldNo:DBL_S32;FieldVal:PVoid):DBL_S32; cdecl;
function  DBL_GetFieldData(Dst:PVoid;DstSize:DBL_S32;hTable:DBL_HTABLE;hRec:DBL_HREC;FieldNo:DBL_S32):DBL_S32; cdecl;
procedure DBL_SelectLatestVersion; cdecl;
procedure DBL_BWT; cdecl;
procedure DBL_AWT; cdecl;
function  DBL_UserID:PDBL_U8; cdecl;
function  DBL_CompanyName:PDBL_U8; cdecl;
function  DBL_UserCount:DBL_S32; cdecl;
function  DBL_Login(UserID,PassWord:PDBL_U8):DBL_BOOL; cdecl;
procedure DBL_Field_2_Str(Str:PDBL_U8;StrSize:DBL_S16;hTable:DBL_HTABLE;Rec:DBL_HREC;FieldNo:DBL_S32); cdecl;
procedure DBL_BCD_2_Str(Str:PDBL_U8;StrSize:DBL_S16;Bcd:PDBL_BCD); cdecl;
procedure DBL_Str_2_BCD(Bcd:PDBL_BCD;Str:PDBL_U8); cdecl;
procedure DBL_YMD_2_Date(Date:PDBL_DATE;y,m,d:DBL_S32;Closing:DBL_BOOL); cdecl;
procedure DBL_Date_2_YMD(y,m,d:PDBL_S32;Closing:PDBL_BOOL;Date:DBL_DATE); cdecl;
procedure DBL_HMST_2_Time(Time:PDBL_TIME;h,m,s,t:DBL_S32); cdecl;
procedure DBL_Time_2_HMST(h,m,s,t:PDBL_S32;Time:DBL_TIME); cdecl;
procedure DBL_Alpha_2_Str(Str:PDBL_U8;StrSize:DBL_S16;Alpha:PDBL_U8); cdecl;
procedure DBL_Str_2_Alpha(Alpha:PDBL_U8;AlphaSize:DBL_S16;Str:PDBL_U8); cdecl;
function  DBL_SetExceptionHandler(ExceptionHandler:DBL_pFuncExceptionHandler):PVoid; cdecl;
function  DBL_GetDatabaseName(DatabaseName:PDBL_U8):DBL_BOOL; cdecl;
procedure DBL_CopyRec(hTable:DBL_HTABLE;hDstRec:DBL_HREC;hSrcRec:DBL_HREC); cdecl;
function  DBL_CmpRec(hTable:DBL_HTABLE;hDstRec:DBL_HREC;hSrcRec:DBL_HREC):DBL_BOOL; cdecl;
function  DBL_SetMessageShowHandler(ShowFunc:DBL_pFuncMessageShowHandler):PVoid; cdecl;
function  DBL_GetLastErrorCode:DBL_S32; cdecl;
procedure DBL_CheckLicenseFile(ObjectNo:DBL_S32); cdecl;
function  DBL_FieldDataOffset(hTable:DBL_HTABLE;FieldNo:DBL_S32):DBL_S16; cdecl;
procedure DBL_Str_2_Date(Date:PDBL_DATE;Str:PDBL_U8); cdecl;
procedure DBL_Date_2_Str(Str:PDBL_U8;StrSize:DBL_S16;Date:DBL_DATE); cdecl;
procedure DBL_Str_2_Time(Time:PDBL_TIME;Str:PDBL_U8); cdecl;
procedure DBL_Time_2_Str(Str:PDBL_U8;StrSize:DBL_S16;Time:DBL_TIME); cdecl;
procedure DBL_ReleaseAllObjects; cdecl;
function  DBL_OpenTemporaryTable(hTablePtr:PDBL_HTABLE;TableNo:DBL_S32):DBL_BOOL; cdecl;

implementation

const
CFRONTDLL = 'cfront.dll';

procedure DBL_Exit; external CFRONTDLL index ID_DBL_EXIT;
function  DBL_Init; external CFRONTDLL index ID_DBL_INIT;
procedure DBL_Allow; external CFRONTDLL index ID_DBL_ALLOW;
function  DBL_GetVersion; external CFRONTDLL index ID_DBL_GETVERSION;
procedure DBL_ConnectServer; external CFRONTDLL index ID_DBL_CONNECTSERVER;
procedure DBL_DisconnectServer; external CFRONTDLL index ID_DBL_DISCONNECTSERVER;
procedure DBL_OpenDatabase; external CFRONTDLL index ID_DBL_OPENDATABASE;
procedure DBL_CloseDatabase; external CFRONTDLL index ID_DBL_CLOSEDATABASE;
function  DBL_NextCompany; external CFRONTDLL index ID_DBL_NEXTCOMPANY;
procedure DBL_OpenCompany; external CFRONTDLL index ID_DBL_OPENCOMPANY;
procedure DBL_CloseCompany; external CFRONTDLL index ID_DBL_CLOSECOMPANY;
function  DBL_NextTable; external CFRONTDLL index ID_DBL_NEXTTABLE;
function  DBL_OpenTable; external CFRONTDLL index ID_DBL_OPENTABLE;
function  DBL_TableName; external CFRONTDLL index ID_DBL_TABLENAME;
function  DBL_TableNo; external CFRONTDLL index ID_DBL_TABLENO;
procedure DBL_CloseTable; external CFRONTDLL index ID_DBL_CLOSETABLE;
procedure DBL_LockTable; external CFRONTDLL index ID_DBL_LOCKTABLE;
function  DBL_AllocRec; external CFRONTDLL index ID_DBL_ALLOCREC;
procedure DBL_FreeRec; external CFRONTDLL index ID_DBL_FREEREC;
function  DBL_FindRec; external CFRONTDLL index ID_DBL_FINDREC;
function  DBL_NextRec; external CFRONTDLL index ID_DBL_NEXTREC;
function  DBL_InsertRec; external CFRONTDLL index ID_DBL_INSERTREC;
function  DBL_DeleteRec; external CFRONTDLL index ID_DBL_DELETEREC;
function  DBL_ModifyRec; external CFRONTDLL index ID_DBL_MODIFYREC;
function  DBL_RecCount; external CFRONTDLL index ID_DBL_RECCOUNT;
procedure DBL_InitRec; external CFRONTDLL index ID_DBL_INITREC;
procedure DBL_CalcFields; external CFRONTDLL index ID_DBL_CALCFIELDS;
procedure DBL_CalcSums; external CFRONTDLL index ID_DBL_CALCSUMS;
function  DBL_KeyCount; external CFRONTDLL index ID_DBL_KEYCOUNT;
function  DBL_NextKey; external CFRONTDLL index ID_DBL_NEXTKEY;
function  DBL_KeySumFields; external CFRONTDLL index ID_DBL_KEYSUMFIELDS;
function  DBL_SetCurrentKey; external CFRONTDLL index ID_DBL_SETCURRENTKEY;
function  DBL_GetCurrentKey; external CFRONTDLL index ID_DBL_GETCURRENTKEY;
procedure DBL_SetFilter; external CFRONTDLL index ID_DBL_SETFILTER;
procedure DBL_GetFilter; external CFRONTDLL index ID_DBL_GETFILTER;
procedure DBL_SetRange; external CFRONTDLL index ID_DBL_SETRANGE;
procedure DBL_GetRange; external CFRONTDLL index ID_DBL_GETRANGE;
function  DBL_FieldCount; external CFRONTDLL index ID_DBL_FIELDCOUNT;
function  DBL_NextField; external CFRONTDLL index ID_DBL_NEXTFIELD;
function  DBL_FieldType; external CFRONTDLL index ID_DBL_FIELDTYPE;
function  DBL_FieldSize; external CFRONTDLL index ID_DBL_FIELDSIZE;
function  DBL_FieldNo; external CFRONTDLL index ID_DBL_FIELDNO;
function  DBL_FieldName; external CFRONTDLL index ID_DBL_FIELDNAME;
function  DBL_FieldOptionStr; external CFRONTDLL index ID_DBL_FIELDOPTIONSTR;
function  DBL_FieldClass; external CFRONTDLL index ID_DBL_FIELDCLASS;
procedure DBL_AssignField; external CFRONTDLL index ID_DBL_ASSIGNFIELD;
function  DBL_GetFieldDataAddr; external CFRONTDLL index ID_DBL_GETFIELDDATAADDR;
function  DBL_GetFieldDataSize; external CFRONTDLL index ID_DBL_GETFIELDDATASIZE;
function  DBL_GetFieldData; external CFRONTDLL index ID_DBL_GETFIELDDATA;
procedure DBL_SelectLatestVersion; external CFRONTDLL index ID_DBL_SELECTLATESTVERSION;
procedure DBL_BWT; external CFRONTDLL index ID_DBL_BWT;
procedure DBL_AWT; external CFRONTDLL index ID_DBL_BWT;
function  DBL_UserID; external CFRONTDLL index ID_DBL_USERID;
function  DBL_CompanyName; external CFRONTDLL index ID_DBL_COMPANYNAME;
function  DBL_UserCount; external CFRONTDLL index ID_DBL_USERCOUNT;
function  DBL_Login; external CFRONTDLL index ID_DBL_LOGIN;
procedure DBL_Field_2_Str; external CFRONTDLL index ID_DBL_FIELD_2_STR;
procedure DBL_BCD_2_Str; external CFRONTDLL index ID_DBL_BCD_2_STR;
procedure DBL_Str_2_BCD; external CFRONTDLL index ID_DBL_STR_2_BCD;
procedure DBL_YMD_2_Date; external CFRONTDLL index ID_DBL_YMD_2_DATE;
procedure DBL_Date_2_YMD; external CFRONTDLL index ID_DBL_DATE_2_YMD;
procedure DBL_HMST_2_Time; external CFRONTDLL index ID_DBL_HMST_2_TIME;
procedure DBL_Time_2_HMST; external CFRONTDLL index ID_DBL_TIME_2_HMST;
procedure DBL_Alpha_2_Str; external CFRONTDLL index ID_DBL_ALPHA_2_STR;
procedure DBL_Str_2_Alpha; external CFRONTDLL index ID_DBL_STR_2_ALPHA;
function  DBL_SetExceptionHandler; external CFRONTDLL index ID_DBL_SETEXCEPTIONHANDLER;
function  DBL_GetDatabaseName; external CFRONTDLL index ID_DBL_GETDATABASENAME;
procedure DBL_CopyRec; external CFRONTDLL index ID_DBL_COPYREC;
function  DBL_CmpRec; external CFRONTDLL index ID_DBL_CMPREC;
function  DBL_SetMessageShowHandler; external CFRONTDLL index ID_DBL_SETMESSAGESHOWHANDLER;
function  DBL_GetLastErrorCode; external CFRONTDLL index ID_DBL_GETLASTERRORCODE;
procedure DBL_CheckLicenseFile; external CFRONTDLL index ID_DBL_CHECKLICENSEFILE;
function  DBL_FieldDataOffset; external CFRONTDLL index ID_DBL_FIELDDATAOFFSET;
procedure DBL_Str_2_Date; external CFRONTDLL index ID_DBL_STR_2_DATE;
procedure DBL_Date_2_Str; external CFRONTDLL index ID_DBL_DATE_2_STR;
procedure DBL_Str_2_Time; external CFRONTDLL index ID_DBL_STR_2_TIME;
procedure DBL_Time_2_Str; external CFRONTDLL index ID_DBL_TIME_2_STR;
procedure DBL_ReleaseAllObjects; external CFRONTDLL index ID_DBL_RELEASEALLOBJECTS;
function  DBL_OpenTemporaryTable; external CFRONTDLL index ID_DBL_OPENTEMPORARYTABLE;
end.
