// *******************************************************************************
// *   C/FRONT W1 3.60 - Delphi declarations
// *   Copyright  2003 Jan Hoek
// *   Release 0.90 (01/2003)
// *******************************************************************************

unit cfront;

interface

uses
  Types;

const
  DBL_Version            = 32;
  DBL_MaxRecSize         = 4000;
  DBL_MaxCompanyNameLen  = 30;
  DBL_MaxTableNameLen    = 30;
  DBL_MaxFieldNameLen    = 30;
  DBL_MaxUserIDLen       = 10;
  DBL_MaxNoOfKeys        = 40;
  DBL_MaxFieldsPerKey    = 20;
  DBL_MaxSumFieldsPerKey = 20;
  DBL_MaxPassWordLen     = 10;

type
  PVoid       = pointer;
  TDBL_U8     = char;
  PDBL_U8     = ^TDBL_U8;
  TDBL_U16    = word;
  TDBL_S16    = smallint;
  TDBL_U32    = cardinal;
  TDBL_S32    = longint;
  PDBL_S32    = ^TDBL_S32;
  TDBL_O32    = longint;
  TDBL_DOUBLE = double;
  PDBL_DOUBLE = ^TDBL_DOUBLE;
  TDBL_BOOL   = longbool;
  PDBL_BOOL   = ^TDBL_BOOL;
  TDBL_DATE   = TDBL_U32;
  PDBL_DATE   = ^TDBL_DATE;
  TDBL_TIME   = TDBL_U32;
  PDBL_TIME   = ^TDBL_TIME;

const
  Module_DB              = 19;
  DBL_Err_TableNotFound  = (((TDBL_S32(Module_DB) * $10000 + TDBL_S32(1008)) or $1000000) or $4000000);
  DBL_Err_RecordNotFound = (((TDBL_S32(Module_DB) * $10000 + TDBL_S32(1008)) or $1000000) or $4000000);
  DBL_Err_RecordExists   = (((TDBL_S32(Module_DB) * $10000 + TDBL_S32(1009)) or $1000000) or $4000000);
  DBL_Err_KeyNotFound    = (((TDBL_S32(Module_DB) * $10000 + TDBL_S32(1007)) or $1000000) or $4000000);

type
  TDBL_BCD = record
    Exp: TDBL_U8;
    Mant: array[0..8] of TDBL_U8;
    Slack: array[0..1] of TDBL_U8;
  end;
  PDBL_BCD = ^TDBL_BCD;

  TDBL_S64 = record
    LowPart: TDBL_U32;
    HighPart: TDBL_S32;
  end;
  PDBL_S64 = ^TDBL_S64;

  TDBL_Duration = TDBL_S64;
  PDBL_Duration = ^TDBL_Duration;
  TDBL_DateTime = TDBL_S64;
  PDBL_Datetime = ^TDBL_DateTime;

  TDBL_GUID = record
    Data1: TDBL_U32;
    Data2: TDBL_U16;
    Data3: TDBL_U16;
    Data4: array[0..7] of TDBL_U8;
  end;
  PDBL_GUID = ^TDBL_GUID;

const
  DBL_BCD_Up        = 1L;
  DBL_BCD_Near      = 0L;
  DBL_BCD_Down      = -1L;
  DBL_Make_Bcd_0    = 0;
  DBL_Make_Bcd_1    = 1;
  DBL_Make_Bcd_2    = 2;
  DBL_Make_Bcd_10   = 3;
  DBL_Make_Bcd_100  = 4;
  DBL_Make_Bcd_1024 = 5;
  DBL_Make_Bcd_MIN  = 6;
  DBL_Make_Bcd_MAX  = 7;

type
  TDBL_HCREATE_TABLE = TDBL_S32;
  PDBL_HCREATE_TABLE = ^TDBL_HCREATE_TABLE;
  TDBL_HREC = DWORD;
  PDBL_HREC = ^TDBL_HREC;
  TDBL_HTABLE = DWORD;
  PDBL_HTABLE = ^TDBL_HTABLE;

  TDBL_pFuncExceptionHandler = procedure(ErrorCode: TDBL_S32; IsFatal: TDBL_BOOL) of object;
  TDBL_pFuncMessageShowHandler = procedure(Msg: PDBL_U8; MessageType: TDBL_U32; ErrorCode: TDBL_S32) of object;

const
  DBL_Class_Normal     = 0;
  DBL_Class_FlowField  = 1;
  DBL_Class_FlowFilter = 2;

  DBL_LockWait   = 0;
  DBL_LockNoWait = 1;

  C_DBL_DirTableNo     = 2000000001;
  F_DBL_DR_ObjType     = 1;
  C_DBL_OT_TableData   = 0;
  C_DBL_OT_TableDesc   = 1;
  C_DBL_OT_Form        = 2;
  C_DBL_OT_Report      = 3;
  C_DBL_OT_Dataport    = 4;
  C_DBL_OT_Codeunit    = 5;
  F_DBL_DR_CompanyName = 2;
  F_DBL_DR_ObjNo       = 3;
  F_DBL_DR_ObjName     = 4;
  F_DBL_DR_Modified    = 5;
  F_DBL_DR_Compiled    = 6;
  F_DBL_DR_Blob        = 7;
  F_DBL_DR_BlobSize    = 8;
  F_DBL_DR_DBMTableNo  = 9;
  F_DBL_DR_StampDate   = 10;
  F_DBL_DR_StampTime   = 11;
  F_DBL_DR_VersionList = 12;

  C_DBL_UserTableNo   = 2000000002;
  F_DBL_UR_UserID     = 1;
  F_DBL_UR_Password   = 2;
  F_DBL_UR_Name       = 3;
  F_DBL_UR_ValidUntil = 4;

  C_DBL_MemberOfTableNo = 2000000003;
  F_DBL_MR_UserID       = 1;
  F_DBL_MR_UserName     = 2;
  F_DBL_MR_GroupID      = 3;
  F_DBL_MR_GroupName    = 4;
  F_DBL_MR_CompanyName  = 5;

  C_DBL_UserGroupTableNo = 2000000004;
  F_DBL_UG_GroupID       = 1;
  F_DBL_UG_Name          = 2;

  C_DBL_PermissionTableNo = 2000000005;
  F_DBL_PR_GroupID        = 1;
  F_DBL_PR_GroupName      = 2;
  F_DBL_PR_ObjType        = 3;
//  C_DBL_OT_TableData      = 0;
//  C_DBL_OT_TableDesc      = 1;
//  C_DBL_OT_Form           = 2;
//  C_DBL_OT_Report         = 3;
//  C_DBL_OT_Dataport       = 4;
//  C_DBL_OT_Codeunit       = 5;
  C_DBL_OT_System         = 10;
  F_DBL_PR_ObjNo          = 4;
  F_DBL_PR_ObjName        = 5;
  F_DBL_PR_Read           = 6;
  F_DBL_PR_Insert         = 7;
  F_DBL_PR_Modify         = 8;
  F_DBL_PR_Delete         = 9;
  F_DBL_PR_Execute        = 10;

  C_DBL_CompanyTableNo = 2000000006;
  F_DBL_CR_Name        = 1;

  C_DBL_DATETableNo    = 2000000007;
  F_DBL_DT_PeriodType  = 1;
  C_DBL_DT_Date        = 0;
  C_DBL_DT_Week        = 1;
  C_DBL_DT_Month       = 2;
  C_DBL_DT_Quarter     = 3;
  C_DBL_DT_Year        = 4;
  F_DBL_DT_PeriodStart = 2;
  F_DBL_DT_PeriodEnd   = 3;

  C_DBL_ConnTableNo     = 2000000009;
  F_DBL_CR_ConnectionID = 1;
  F_DBL_CR_UserID       = 2;
  F_DBL_CR_MySession    = 3;
  F_DBL_CR_UserName     = 4;
  F_DBL_CR_LoginTime    = 5;
  F_DBL_CR_LoginDate    = 6;
  F_DBL_CR_CacheReads   = 7;
  F_DBL_CR_DiskReads    = 8;
  F_DBL_CR_DiskWrites   = 9;
  F_DBL_CR_RecsFound    = 10;
  F_DBL_CR_RecsScanned  = 11;
  F_DBL_CR_RecsInserted = 12;
  F_DBL_CR_RecsDeleted  = 13;
  F_DBL_CR_RecsModified = 14;
  F_DBL_CR_SumIntervals = 15;

  C_DBL_DatabaseFilesTableNo = 2000000010;
  F_DBL_DF_No                = 1;
  F_DBL_DF_OSFileName        = 2;
  F_DBL_DF_SizeInKb          = 3;
  F_DBL_DF_TotalReads        = 4;
  F_DBL_DF_MeanReadTimeMS    = 5;
  F_DBL_DF_ReadsInQueue      = 6;
  F_DBL_DF_TotalWrites       = 7;
  F_DBL_DF_MeanWriteTimeMS   = 8;
  F_DBL_DF_WritesInQueue     = 9;
  F_DBL_DF_DiskLoadInPct     = 10;

  C_DBL_DRIVETableNo  = 2000000020;
  F_DBL_DRT_Drive     = 1;
  F_DBL_DRT_Removable = 2;
  F_DBL_DRT_SizeInKb  = 3;
  F_DBL_DRT_FreeInKb  = 4;

  C_DBL_FILETableNo = 2000000022;
  F_DBL_FT_Path     = 1;
  F_DBL_FT_IsFile   = 2;
  F_DBL_FT_Name     = 3;
  F_DBL_FT_Size     = 4;
  F_DBL_FT_Date     = 5;
  F_DBL_FT_Time     = 6;
  F_DBL_FT_Data     = 7;

  C_DBL_MoniTableNo        = 2000000024;
  F_DBL_MT_CallNo          = 1;
  F_DBL_MT_FuncType        = 2;
  F_DBL_MT_ParameterSeqNo  = 3;
  F_DBL_MT_Parameter       = 4;
  C_DBL_TableParmNo        = 1;
  C_DBL_SearchRecParmNo    = 2;
  C_DBL_SearchIndexParmNo  = 3;
  C_DBL_FilterParmNo       = 4;
  C_DBL_SearchStrParmNo    = 5;
  C_DBL_SearchResultParmNo = 6;
  C_DBL_FoundRecParmNo     = 7;
  C_DBL_RealsParmNo        = 8;
  C_DBL_TimeUsedParmNo     = 9;
  C_DBL_RecsScannedParmNo  = 10;
  C_DBL_SumIntervalsParmNo = 11;
  C_DBL_RecsDeletedParmNo  = 12;
  C_DBL_DiskReadParmNo     = 13;
  C_DBL_DiskWriteParmNo    = 14;
  C_DBL_RecordParmNo       = 15;
  C_DBL_WaitParmNo         = 16;
  C_DBL_SumFieldsParmNo    = 17;
  C_DBL_BlobFieldParmNo    = 18;
  C_DBL_CommitParmNo       = 19;
  C_DBL_UserIDParmNo       = 20;
  C_DBL_FileNameParmNo     = 21;
  F_DBL_MT_Number          = 5;
  F_DBL_MT_Data            = 6;

  C_DBL_S32TableNo = 2000000026;
  F_DBL_DT_S32     = 1;

  C_DBL_TITableNo        = 2000000028;
  F_DBL_TI_CompanyName   = 1;
  F_DBL_TI_ObjNo         = 2;
  F_DBL_TI_ObjName       = 3;
  F_DBL_TI_NoOfRecs      = 4;
  F_DBL_TI_RecSize       = 5;
  F_DBL_TI_TableSizeInKb = 6;
  F_DBL_TI_Utilization   = 7;

  C_DBL_SysObjTableNo = 2000000029;
  F_DBL_SYO_ObjType   = F_DBL_DR_ObjType;
//  C_DBL_OT_TableData  = 0;
//  C_DBL_OT_TableDesc  = 1;
//  C_DBL_OT_Form       = 2;
//  C_DBL_OT_Report     = 3;
//  C_DBL_OT_Dataport   = 4;
//  C_DBL_OT_Codeunit   = 5;
//  C_DBL_OT_System     = 10;
  F_DBL_SYO_ObjNo     = F_DBL_DR_ObjNo;
  F_DBL_SYO_ObjName   = F_DBL_DR_ObjName;

  C_DBL_PERFTableNo   = 2000000037;
  F_DBL_PERF_No       = 1;
  F_DBL_PERF_Name     = 2;
  F_DBL_PERF_Value    = 3;
  F_DBL_PERF_Unit     = 4;

  C_DBL_AllObjTableNo = 2000000038;
  F_DBL_ALLO_ObjType  = F_DBL_DR_ObjType;
  F_DBL_ALLO_ObjNo    = F_DBL_DR_ObjNo;
  F_DBL_ALLO_ObjName  = F_DBL_DR_ObjName;

  C_DBL_PRINTERTableNo = 2000000039;
  F_DBL_PDR_ID         = 1;
  F_DBL_PDR_Name       = 2;
  F_DBL_PDR_Driver     = 3;
  F_DBL_PDR_Device     = 4;

  C_DBL_LicenseTableNo = 2000000040;
  F_DBL_LIC_LineNo     = 1;
  F_DBL_LIC_Text       = 2;

  C_DBL_AFIELDTableNo     = 2000000041;
  F_DBL_AFIELDT_TableNo   = 1;
  F_DBL_AFIELDT_No        = 2;
  F_DBL_AFIELDT_TableName = 3;
  F_DBL_AFIELDT_FieldName = 4;
  F_DBL_AFIELDT_Type      = 5;
  F_DBL_AFIELDT_Len       = 6;
  F_DBL_AFIELDT_Class     = 7;
  F_DBL_AFIELDT_Enabled   = 8;
  F_DBL_AFIELDT_TypeName  = 9;

const
  DBL_Type_STR         =  45 * $100;
  DBL_Type_DATE        =  46 * $100;
  DBL_Type_TIME        =  46 * $100 + 1;
  DBL_Type_BLOB        = 132 * $100 + 2;
  DBL_Type_BOOL        = 133 * $100;
  DBL_Type_S16         = 134 * $100;
  DBL_Type_S32         = 135 * $100;
  DBL_Type_U8          = 136 * $100;
  DBL_Type_ALPHA       = 137 * $100;
  DBL_Type_O32         = 139 * $100;
  DBL_Type_BCD         =  50 * $100;
  DBL_Type_DATEFORMULA =  46 * $100 + 22;
  DBL_Type_S64         = 141 * $100;
  DBL_Type_Duration    = 144 * $100;
  DBL_Type_Datetime    = 146 * $100;
  DBL_Type_GUID        = 145 * $100;

  DBL_Msg_Critical = $002010;
  DBL_Msg_Warning  = $002030;

const
  ID_DBL_ALLOW                            = 1;
  ID_DBL_GETVERSION                       = 2;
  ID_DBL_INIT                             = 3;
  ID_DBL_EXIT                             = 4;
  ID_DBL_CONNECTSERVER                    = 5;
  ID_DBL_DISCONNECTSERVER                 = 6;
  ID_DBL_OPENDATABASE                     = 7;
  ID_DBL_CLOSEDATABASE                    = 8;
  ID_DBL_OPENCOMPANY                      = 9;
  ID_DBL_CLOSECOMPANY                     = 10;
  ID_DBL_NEXTTABLE                        = 11;
  ID_DBL_OPENTABLE                        = 12;
  ID_DBL_TABLENAME                        = 13;
  ID_DBL_CLOSETABLE                       = 14;
  ID_DBL_LOCKTABLE                        = 15;
  ID_DBL_FINDREC                          = 16;
  ID_DBL_NEXTREC                          = 17;
  ID_DBL_INSERTREC                        = 18;
  ID_DBL_DELETEREC                        = 19;
  ID_DBL_MODIFYREC                        = 20;
  ID_DBL_RECCOUNT                         = 21;
  ID_DBL_INITREC                          = 22;
  ID_DBL_CALCFIELDS                       = 23;
  ID_DBL_CALCSUMS                         = 24;
  ID_DBL_KEYCOUNT                         = 25;
  ID_DBL_NEXTKEY                          = 26;
  ID_DBL_KEYSUMFIELDS                     = 27;
  ID_DBL_SETCURRENTKEY                    = 28;
  ID_DBL_GETCURRENTKEY                    = 29;
  ID_DBL_SETFILTER                        = 30;
  ID_DBL_GETFILTER                        = 31;
  ID_DBL_SETRANGE                         = 32;
  ID_DBL_GETRANGE                         = 33;
  ID_DBL_FIELDCOUNT                       = 34;
  ID_DBL_NEXTFIELD                        = 35;
  ID_DBL_FIELDTYPE                        = 36;
  ID_DBL_FIELDSIZE                        = 37;
  ID_DBL_FIELDNAME                        = 38;
  ID_DBL_FIELDOPTIONSTR                   = 39;
  ID_DBL_FIELDCLASS                       = 40;
  ID_DBL_ASSIGNFIELD                      = 41;
  ID_DBL_GETFIELDDATAADDR                 = 42;
  ID_DBL_GETFIELDDATASIZE                 = 43;
  ID_DBL_GETFIELDDATA                     = 44;
  ID_DBL_SELECTLATESTVERSION              = 45;
  ID_DBL_BWT                              = 46;
  ID_DBL_EWT                              = 47;
  ID_DBL_AWT                              = 48;
  ID_DBL_USERID                           = 49;
  ID_DBL_COMPANYNAME                      = 50;
  ID_DBL_USERCOUNT                        = 51;
  ID_DBL_LOGIN                            = 52;
  ID_DBL_FIELD_2_STR                      = 53;
  ID_DBL_BCD_2_STR                        = 54;
  ID_DBL_STR_2_BCD                        = 55;
  ID_DBL_YMD_2_DATE                       = 56;
  ID_DBL_DATE_2_YMD                       = 57;
  ID_DBL_HMST_2_TIME                      = 58;
  ID_DBL_TIME_2_HMST                      = 59;
  ID_DBL_ALPHA_2_STR                      = 60;
  ID_DBL_STR_2_ALPHA                      = 61;
  ID_DBL_NEXTCOMPANY                      = 62;
  ID_DBL_TABLENO                          = 63;
  ID_DBL_FIELDNO                          = 64;
  ID_DBL_ALLOCREC                         = 65;
  ID_DBL_FREEREC                          = 66;
  ID_DBL_SETEXCEPTIONHANDLER              = 67;
  ID_DBL_GETDATABASENAME                  = 68;
  ID_DBL_COPYREC                          = 69;
  ID_DBL_CMPREC                           = 70;
  ID_DBL_SETMESSAGESHOWHANDLER            = 71;
  ID_DBL_GETLASTERRORCODE                 = 72;
  ID_DBL_CHECKLICENSEFILE                 = 73;
  ID_DBL_FIELDDATAOFFSET                  = 74;
  ID_DBL_STR_2_DATE                       = 75;
  ID_DBL_DATE_2_STR                       = 76;
  ID_DBL_STR_2_TIME                       = 77;
  ID_DBL_TIME_2_STR                       = 78;
  ID_DBL_RELEASEALLOBJECTS                = 79;
  ID_DBL_OPENTEMPORARYTABLE               = 80;
  ID_DBL_FIELDLEN                         = 81;
  ID_DBL_CREATETABLEBEGIN                 = 82;
  ID_DBL_ADDTABLEFIELD                    = 83;
  ID_DBL_ADDKEY                           = 84;
  ID_DBL_CREATETABLE                      = 85;
  ID_DBL_CREATETABLEEND                   = 86;
  ID_DBL_DELETETABLE                      = 87;
  ID_DBL_SETNAVISIONPATH                  = 88;
  ID_DBL_LOADLICENSEFILE                  = 89;
  ID_DBL_CRYPTPASSWORD                    = 90;
  ID_DBL_DELETERECS                       = 91;
  ID_DBL_BCD_2_DOUBLE                     = 92;
  ID_DBL_DOUBLE_2_BCD                     = 93;
  ID_DBL_BCD_2_S32                        = 94;
  ID_DBL_S32_2_BCD                        = 95;
  ID_DBL_BCD_ISZERO                       = 96;
  ID_DBL_BCD_ISNEGATIVE                   = 97;
  ID_DBL_BCD_ISPOSITIVE                   = 98;
  ID_DBL_BCD_DIV                          = 99;
  ID_DBL_BCD_MUL                          = 100;
  ID_DBL_BCD_ADD                          = 101;
  ID_DBL_BCD_SUB                          = 102;
  ID_DBL_BCD_ABS                          = 103;
  ID_DBL_BCD_NEG                          = 104;
  ID_DBL_BCD_POWER                        = 105;
  ID_DBL_BCD_SGN                          = 106;
  ID_DBL_BCD_CMP                          = 107;
  ID_DBL_BCD_TRUNC                        = 108;
  ID_DBL_BCD_ROUND                        = 109;
  ID_DBL_BCD_ROUNDUNIT                    = 110;
  ID_DBL_BCD_MAKE                         = 111;
  ID_DBL_CONNECTSERVERANDOPENDATABASE     = 112;
  ID_DBL_OEM2ANSIBUFF                     = 113;
  ID_DBL_ANSI2OEMBUFF                     = 114;
  ID_DBL_USECODEUNITSPERMISSIONS          = 115;
  ID_DBL_TABLEISSAME                      = 116;
  ID_DBL_TABLEDUP                         = 117;
  ID_DBL_DUPREC                           = 118;
  ID_DBL_SETVIEW                          = 119;
  ID_DBL_GETVIEW                          = 120;
  ID_DBL_SETTRANSFER                      = 121;
  ID_DBL_DATEFORMULA_2_STR                = 122;
  ID_DBL_STR_2_DATEFORMULA                = 123;
  ID_DBL_S64_2_STR                        = 124;
  ID_DBL_STR_2_S64                        = 125;
  ID_DBL_S64_2_S32                        = 126;
  ID_DBL_S32_2_S64                        = 127;
  ID_DBL_DURATION_2_STR                   = 128;
  ID_DBL_STR_2_DURATION                   = 129;
  ID_DBL_DATETIME_2_STR                   = 130;
  ID_DBL_STR_2_DATETIME                   = 131;
  ID_DBL_DATETIME_2_YMDHMST               = 132;
  ID_DBL_YMDHMST_2_DATETIME               = 133;
  ID_DBL_GUID_2_STR                       = 134;
  ID_DBL_STR_2_GUID                       = 135;

procedure DBL_Exit; cdecl;
function  DBL_Init: TDBL_S32; cdecl;
procedure DBL_Allow(ErrorCode: TDBL_S32); cdecl;
function  DBL_GetVersion: TDBL_S32; cdecl;
procedure DBL_ConnectServer(ServerName, NetType: PDBL_U8); cdecl;
procedure DBL_DisconnectServer; cdecl;
procedure DBL_OpenDatabase(DatabaseName: PDBL_U8; CacheSize: TDBL_S32; UseCommitCache: TDBL_BOOL); cdecl;
procedure DBL_CloseDatabase; cdecl;
function  DBL_NextCompany(CompanyName: PDBL_U8): PDBL_U8; cdecl;
procedure DBL_OpenCompany(CompanyName: PDBL_U8); cdecl;
procedure DBL_CloseCompany; cdecl;
function  DBL_NextTable(TableNo: TDBL_S32): TDBL_S32; cdecl;
function  DBL_OpenTable(hTablePtr: PDBL_HTABLE; TableNo: TDBL_S32): TDBL_BOOL; cdecl;
function  DBL_TableName(hTable: TDBL_HTABLE): PDBL_U8; cdecl;
function  DBL_TableNo(TableName: PDBL_U8): TDBL_S32; cdecl;
procedure DBL_CloseTable(hTable: TDBL_HTABLE); cdecl;
procedure DBL_LockTable(hTable: TDBL_HTABLE; MOde: TDBL_U32); cdecl;
function  DBL_AllocRec(hTable: TDBL_HTABLE): TDBL_HREC; cdecl;
procedure DBL_FreeRec(Rec: TDBL_HREC); cdecl;
function  DBL_FindRec(hTable: TDBL_HTABLE; Rec: TDBL_HREC; SearchMethod: PDBL_U8): TDBL_BOOL; cdecl;
function  DBL_NextRec(hTable: TDBL_HTABLE; Rec: TDBL_HREC; Step: TDBL_S16): TDBL_S16; cdecl;
function  DBL_InsertRec(hTable: TDBL_HTABLE; Rec: TDBL_HREC): TDBL_BOOL; cdecl;
function  DBL_DeleteRec(hTable: TDBL_HTABLE; Rec: TDBL_HREC): TDBL_BOOL; cdecl;
function  DBL_ModifyRec(hTable: TDBL_HTABLE; Rec: TDBL_HREC): TDBL_BOOL; cdecl;
function  DBL_RecCount(hTable: TDBL_HTABLE): TDBL_S32; cdecl;
procedure DBL_InitRec(hTable: TDBL_HTABLE; Rec: TDBL_HREC); cdecl;
procedure DBL_CalcFields(hTable: TDBL_HTABLE; Rec: TDBL_HREC; FieldList: PDBL_S32); cdecl;
procedure DBL_CalcSums(hTable: TDBL_HTABLE; Rec: TDBL_HREC; FieldList: PDBL_S32); cdecl;
function  DBL_KeyCount(hTable: TDBL_HTABLE): TDBL_S16; cdecl;
function  DBL_NextKey(hTable: TDBL_HTABLE; Key: PDBL_S32): PDBL_S32; cdecl;
function  DBL_KeySumFields(hTable: TDBL_HTABLE; Key: PDBL_S32): PDBL_S32; cdecl;
function  DBL_SetCurrentKey(hTable: TDBL_HTABLE; Key: PDBL_S32): TDBL_BOOL; cdecl;
function  DBL_GetCurrentKey(hTable: TDBL_HTABLE): PDBL_S32; cdecl;
procedure DBL_SetFilter(hTable: TDBL_HTABLE; FieldNo: TDBL_S32; FilterStr: PDBL_U8; ValuePtr1: PVoid);
function  DBL_GetFilter(hTable: TDBL_HTABLE; FieldNo: TDBL_S32; FilterStr: PDBL_U8; FilterStrSize: TDBL_S16): TDBL_S32; cdecl;
procedure DBL_SetRange(hTable: TDBL_HTABLE; FieldNo: TDBL_S32; MinValue, MaxValue: PVoid); cdecl;
procedure DBL_GetRange(hTable: TDBL_HTABLE; FieldNo: TDBL_S32; MinValue, MaxValue: PVoid); cdecl;
function  DBL_FieldCount(hTable: TDBL_HTABLE): TDBL_S16; cdecl;
function  DBL_NextField(hTable: TDBL_HTABLE; FieldNo: TDBL_S32): TDBL_S32; cdecl;
function  DBL_FieldType(hTable: TDBL_HTABLE; FieldNo: TDBL_S32): TDBL_U16; cdecl;
function  DBL_FieldSize(hTable: TDBL_HTABLE; FieldNo: TDBL_S32): TDBL_S16; cdecl;
function  DBL_FieldNo(hTable: TDBL_HTABLE; FieldName: PDBL_U8): TDBL_S32; cdecl;
function  DBL_FieldName(hTable: TDBL_HTABLE; FieldNo: TDBL_S32): PDBL_U8; cdecl;
function  DBL_FieldOptionStr(hTable: TDBL_HTABLE; FieldNo: TDBL_S32): PDBL_U8; cdecl;
function  DBL_FieldClass(hTable: TDBL_HTABLE; FieldNo: TDBL_S32): TDBL_S16; cdecl;
procedure DBL_AssignField(hTable: TDBL_HTABLE; hRec: TDBL_HREC; FieldNo: TDBL_S32; FieldType: TDBL_U16; Data: PVoid; DataSize: TDBL_S32); cdecl;
function  DBL_GetFieldDataAddr(hTable: TDBL_HTABLE; hRec: TDBL_HTABLE; FieldNo: TDBL_S32): PVoid; cdecl;
function  DBL_GetFieldDataSize(hTable: TDBL_HTABLE; FieldNo: TDBL_S32; FieldVal: PVoid): TDBL_S32; cdecl;
function  DBL_GetFieldData(Dst: PVoid; DstSize: TDBL_S32; hTable: TDBL_HTABLE; hRec: TDBL_HREC; FieldNo: TDBL_S32): TDBL_S32; cdecl;
procedure DBL_SelectLatestVersion; cdecl;
procedure DBL_BWT; cdecl;
procedure DBL_EWT; cdecl;
procedure DBL_AWT; cdecl;
function  DBL_UserID: PDBL_U8; cdecl;
function  DBL_CompanyName: PDBL_U8; cdecl;
function  DBL_UserCount: TDBL_S32; cdecl;
function  DBL_Login(UserID, PassWord: PDBL_U8): TDBL_BOOL; cdecl;
procedure DBL_Field_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; hTable: TDBL_HTABLE; Rec: TDBL_HREC; FieldNo: TDBL_S32); cdecl;
procedure DBL_BCD_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; Bcd: PDBL_BCD); cdecl;
procedure DBL_Str_2_BCD(Bcd: PDBL_BCD; Str: PDBL_U8); cdecl;
procedure DBL_YMD_2_Date(Date: PDBL_DATE; y, m, d: TDBL_S32; Closing: TDBL_BOOL); cdecl;
procedure DBL_Date_2_YMD(y, m, d: PDBL_S32; Closing: PDBL_BOOL; Date: TDBL_DATE); cdecl;
procedure DBL_HMST_2_Time(Time: PDBL_TIME; h, m, s, t: TDBL_S32); cdecl;
procedure DBL_Time_2_HMST(h, m, s, t: PDBL_S32; Time: TDBL_Time); cdecl;
procedure DBL_Alpha_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; Alpha: PDBL_U8); cdecl;
procedure DBL_Str_2_Alpha(Alpha: PDBL_U8; AlphaSize: TDBL_S16; Str: PDBL_U8); cdecl;
function  DBL_SetExceptionHandler(ExceptionHandler: TDBL_pFuncExceptionHandler): PVoid; cdecl;
function  DBL_GetDatabaseName(DatabaseName: PDBL_U8): TDBL_BOOL; cdecl;
procedure DBL_CopyRec(hTable: TDBL_HTABLE; hDstRec: TDBL_HREC; hSrcRec: TDBL_HREC); cdecl;
function  DBL_CmpRec(hTable: TDBL_HTABLE; hDstRec, hSrcRec: TDBL_HREC): TDBL_BOOL; cdecl;
function  DBL_SetMessageShowHandler(ShowFunc: TDBL_pFuncMessageShowHandler): PVoid; cdecl;
function  DBL_GetLastErrorCode: TDBL_S32; cdecl;
procedure DBL_CheckLicenseFile(ObjectNo: TDBL_S32); cdecl;
function  DBL_FieldDataOffset(hTable: TDBL_HTABLE; FieldNo: TDBL_S32): TDBL_S16; cdecl;
procedure DBL_Str_2_Date(Date: PDBL_DATE; Str: PDBL_U8); cdecl;
procedure DBL_Date_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; Date: TDBL_DATE); cdecl;
procedure DBL_Str_2_Time(Time: PDBL_TIME; Str: PDBL_U8); cdecl;
procedure DBL_Time_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; Time: TDBL_TIME); cdecl;
procedure DBL_ReleaseAllObjects; cdecl;
function  DBL_OpenTemporaryTable(hTablePtr: PDBL_HTABLE; TableNo: TDBL_S32): TDBL_BOOL; cdecl;
function  DBL_FieldLen(hTable: TDBL_HTABLE; FieldNo: TDBL_S32): TDBL_S16; cdecl;
procedure DBL_CreateTableBegin(phCT: PDBL_HCREATE_TABLE; TableNo: TDBL_S32; TableName: PDBL_U8; DataPerCompany: TDBL_BOOL); cdecl;
procedure DBL_AddTableField(hCT: TDBL_HCREATE_TABLE; FieldNo: TDBL_S32; FieldName: PDBL_U8; FieldType: TDBL_U16; FieldLen: TDBL_S16; OptionStr: PDBL_U8; FieldClass: TDBL_S16); cdecl;
procedure DBL_AddKey(hCT: TDBL_HCREATE_TABLE; Key, SumIndexFields: PDBL_S32); cdecl;
function  DBL_CreateTable(hCT: TDBL_HCREATE_TABLE): TDBL_BOOL; cdecl;
procedure DBL_CreateTableEnd(hCT: TDBL_HCREATE_TABLE); cdecl;
function  DBL_DeleteTable(TableNo: TDBL_S32): TDBL_BOOL; cdecl;
procedure DBL_SetNavisionPath(Path: PDBL_U8); cdecl;
procedure DBL_LoadLicenseFile(FileName: PDBL_U8); cdecl;
procedure DBL_CryptPassword(UserID, PassWord: PDBL_U8); cdecl;
procedure DBL_DeleteRecs(hTable: TDBL_HTABLE); cdecl;
procedure DBL_BCD_2_Double(Dest: PDBL_DOUBLE; Source: PDBL_BCD); cdecl;
procedure DBL_Double_2_BCD(Dest: PDBL_BCD; Source: TDBL_DOUBLE); cdecl;
function  DBL_BCD_2_S32(Source: PDBL_BCD): TDBL_S32; cdecl;
procedure DBL_S32_2_BCD(Dest: PDBL_BCD; Source: TDBL_S32); cdecl;
function  DBL_BCD_IsZero(Source: PDBL_BCD): TDBL_BOOL; cdecl;
function  DBL_BCD_IsNegative(Source: PDBL_BCD): TDBL_BOOL; cdecl;
function  DBL_BCD_IsPositive(Source: PDBL_BCD): TDBL_BOOL; cdecl;
function  DBL_BCD_Div(Dest, Source: PDBL_BCD): PDBL_BCD; cdecl;
function  DBL_BCD_Mul(Dest, Source: PDBL_BCD): PDBL_BCD; cdecl;
function  DBL_BCD_Add(Dest, Source: PDBL_BCD): PDBL_BCD; cdecl;
function  DBL_BCD_Sub(Dest, Source: PDBL_BCD): PDBL_BCD; cdecl;
procedure DBL_BCD_Abs(Dest: PDBL_BCD); cdecl;
procedure DBL_BCD_Neg(Dest: PDBL_BCD); cdecl;
function  DBL_BCD_Power(Dest: PDBL_BCD; Power: PDBL_BCD): PDBL_BCD; cdecl;
function  DBL_BCD_Sgn(Source: PDBL_BCD): TDBL_S32; cdecl;
function  DBL_BCD_Cmp(Left, Right: PDBL_BCD): TDBL_S32; cdecl;
procedure DBL_BCD_Trunc(Dest: PDBL_BCD; Cnt: TDBL_S32); cdecl;
procedure DBL_BCD_Round(Dest: PDBL_BCD; Cnt: TDBL_S32); cdecl;
procedure DBL_BCD_RoundUnit(Dest, RndUnit: PDBL_BCD; How: TDBL_S32); cdecl;
function  DBL_BCD_Make(Dest: PDBL_BCD; Kind: TDBL_S32): PDBL_BCD; cdecl;
procedure DBL_ConnectServerAndOpenDatabase(NDBCDriverName, ServerName, NetType, DatabaseName: PDBL_U8; CacheSize: TDBL_S32;
  UseCommitCache, UseNTAuthentication: TDBL_BOOL; UserID, PassWord: PDBL_U8); cdecl;
procedure DBL_Oem2AnsiBuff(Src, Dst: PDBL_U8; DstSize: TDBL_S32); cdecl;
procedure DBL_Ansi2OemBuff(Src, Dst: PDBL_U8; DstSize: TDBL_S32); cdecl;
procedure DBL_UseCodeUnitsPermissions(CodeUnitID: TDBL_S32); cdecl;
function  DBL_TableIsSame(hTable1, hTable2:TDBL_HTABLE): TDBL_BOOL; cdecl;
function  DBL_TableDup(hSrcTable: TDBL_HTABLE): TDBL_HTABLE; cdecl;
function  DBL_DupRec(hTable: TDBL_HTABLE; hSrcRec: TDBL_HREC): TDBL_HREC; cdecl;
procedure DBL_SetView(hTable: TDBL_HTABLE; ViewStr: PDBL_U8); cdecl;
procedure DBL_GetView(hTable: TDBL_HTABLE; ViewStrBuffer: PDBL_U8; ViewStrBufferSize: TDBL_S32; UseFieldNames: TDBL_BOOL); cdecl;
function  DBL_SetTransfer(hInnerTable, hOuterTable: PDBL_HTABLE; hInnerRec, hOuterRec: PDBL_HREC; TFormula: PDBL_U8): TDBL_BOOL; cdecl;
procedure DBL_DateFormula_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; DateFormula: PDBL_U8); cdecl;
procedure DBL_Str_2_DateFormula(DateFormula: PDBL_U8; DateFormulaSize: TDBL_S16; Str: PDBL_U8); cdecl;
procedure DBL_S64_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; S64Src: PDBL_S64); cdecl;
procedure DBL_Str_2_S64(S64Dest: PDBL_S64; Str: PDBL_U8); cdecl;
procedure DBL_S64_2_S32(S32: PDBL_S32; S64Src: PDBL_S64); cdecl;
procedure DBL_S32_2_S64(S64Dest: PDBL_S64; S32: TDBL_S32); cdecl;
procedure DBL_Duration_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; DurationSrc: PDBL_Duration); cdecl;
procedure DBL_Str_2_Duration(DurationDest: PDBL_Duration; Str: PDBL_U8); cdecl;
procedure DBL_Datetime_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; DatetimeSrc: PDBL_Datetime); cdecl;
procedure DBL_Str_2_Datetime(DatetimeDest: PDBL_Datetime; Str: PDBL_U8); cdecl;
procedure DBL_Datetime_2_YMDHMST(Year, Month, Day, Hour, Minute, Second, Fraction: PDBL_S32; DatetimeSrc: PDBL_Datetime); cdecl;
procedure DBL_YMDHMST_2_Datetime(DatetimeDest: PDBL_Datetime; Year, Month, Day, Hour, Minute, Second, Fraction: TDBL_S32); cdecl;
procedure DBL_GUID_2_Str(Str: PDBL_U8; StrSize: TDBL_S16; GuidSrc: PDBL_GUID); cdecl;
procedure DBL_Str_2_GUID(GuidDest: PDBL_GUID; Str: PDBL_U8); cdecl;

implementation

const
  DLLName = 'cfront.dll';

procedure DBL_Exit;                         external DLLName index ID_DBL_EXIT;
function  DBL_Init;                         external DLLName index ID_DBL_INIT;
procedure DBL_Allow;                        external DLLName index ID_DBL_ALLOW;
function  DBL_GetVersion;                   external DLLName index ID_DBL_GETVERSION;
procedure DBL_ConnectServer;                external DLLName index ID_DBL_CONNECTSERVER;
procedure DBL_DisconnectServer;             external DLLName index ID_DBL_DISCONNECTSERVER;
procedure DBL_OpenDatabase;                 external DLLName index ID_DBL_OPENDATABASE;
procedure DBL_CloseDatabase;                external DLLName index ID_DBL_CLOSEDATABASE;
function  DBL_NextCompany;                  external DLLName index ID_DBL_NEXTCOMPANY;
procedure DBL_OpenCompany;                  external DLLName index ID_DBL_OPENCOMPANY;
procedure DBL_CloseCompany;                 external DLLName index ID_DBL_CLOSECOMPANY;
function  DBL_NextTable;                    external DLLName index ID_DBL_NEXTTABLE;
function  DBL_OpenTable;                    external DLLName index ID_DBL_OPENTABLE;
function  DBL_TableName;                    external DLLName index ID_DBL_TABLENAME;
function  DBL_TableNo;                      external DLLName index ID_DBL_TABLENO;
procedure DBL_CloseTable;                   external DLLName index ID_DBL_CLOSETABLE;
procedure DBL_LockTable;                    external DLLName index ID_DBL_LOCKTABLE;
function  DBL_AllocRec;                     external DLLName index ID_DBL_ALLOCREC;
procedure DBL_FreeRec;                      external DLLName index ID_DBL_FREEREC;
function  DBL_FindRec;                      external DLLName index ID_DBL_FINDREC;
function  DBL_NextRec;                      external DLLName index ID_DBL_NEXTREC;
function  DBL_InsertRec;                    external DLLName index ID_DBL_INSERTREC;
function  DBL_DeleteRec;                    external DLLName index ID_DBL_DELETEREC;
function  DBL_ModifyRec;                    external DLLName index ID_DBL_MODIFYREC;
function  DBL_RecCount;                     external DLLName index ID_DBL_RECCOUNT;
procedure DBL_InitRec;                      external DLLName index ID_DBL_INITREC;
procedure DBL_CalcFields;                   external DLLName index ID_DBL_CALCFIELDS;
procedure DBL_CalcSums;                     external DLLName index ID_DBL_CALCSUMS;
function  DBL_KeyCount;                     external DLLName index ID_DBL_KEYCOUNT;
function  DBL_NextKey;                      external DLLName index ID_DBL_NEXTKEY;
function  DBL_KeySumFields;                 external DLLName index ID_DBL_KEYSUMFIELDS;
function  DBL_SetCurrentKey;                external DLLName index ID_DBL_SETCURRENTKEY;
function  DBL_GetCurrentKey;                external DLLName index ID_DBL_GETCURRENTKEY;
procedure DBL_SetFilter;                    external DLLName index ID_DBL_SETFILTER;
function  DBL_GetFilter;                    external DLLName index ID_DBL_GETFILTER;
procedure DBL_SetRange;                     external DLLName index ID_DBL_SETRANGE;
procedure DBL_GetRange;                     external DLLName index ID_DBL_GETRANGE;
function  DBL_FieldCount;                   external DLLName index ID_DBL_FIELDCOUNT;
function  DBL_NextField;                    external DLLName index ID_DBL_NEXTFIELD;
function  DBL_FieldType;                    external DLLName index ID_DBL_FIELDTYPE;
function  DBL_FieldSize;                    external DLLName index ID_DBL_FIELDSIZE;
function  DBL_FieldNo;                      external DLLName index ID_DBL_FIELDNO;
function  DBL_FieldName;                    external DLLName index ID_DBL_FIELDNAME;
function  DBL_FieldOptionStr;               external DLLName index ID_DBL_FIELDOPTIONSTR;
function  DBL_FieldClass;                   external DLLName index ID_DBL_FIELDCLASS;
procedure DBL_AssignField;                  external DLLName index ID_DBL_ASSIGNFIELD;
function  DBL_GetFieldDataAddr;             external DLLName index ID_DBL_GETFIELDDATAADDR;
function  DBL_GetFieldDataSize;             external DLLName index ID_DBL_GETFIELDDATASIZE;
function  DBL_GetFieldData;                 external DLLName index ID_DBL_GETFIELDDATA;
procedure DBL_SelectLatestVersion;          external DLLName index ID_DBL_SELECTLATESTVERSION;
procedure DBL_BWT;                          external DLLName index ID_DBL_BWT;
procedure DBL_EWT;                          external DLLName index ID_DBL_EWT;
procedure DBL_AWT;                          external DLLName index ID_DBL_AWT;
function  DBL_UserID;                       external DLLName index ID_DBL_USERID;
function  DBL_CompanyName;                  external DLLName index ID_DBL_COMPANYNAME;
function  DBL_UserCount;                    external DLLName index ID_DBL_USERCOUNT;
function  DBL_Login;                        external DLLName index ID_DBL_LOGIN;
procedure DBL_Field_2_Str;                  external DLLName index ID_DBL_FIELD_2_STR;
procedure DBL_BCD_2_Str;                    external DLLName index ID_DBL_BCD_2_STR;
procedure DBL_Str_2_BCD;                    external DLLName index ID_DBL_STR_2_BCD;
procedure DBL_YMD_2_Date;                   external DLLName index ID_DBL_YMD_2_DATE;
procedure DBL_Date_2_YMD;                   external DLLName index ID_DBL_DATE_2_YMD;
procedure DBL_HMST_2_Time;                  external DLLName index ID_DBL_HMST_2_TIME;
procedure DBL_Time_2_HMST;                  external DLLName index ID_DBL_TIME_2_HMST;
procedure DBL_Alpha_2_Str;                  external DLLName index ID_DBL_ALPHA_2_STR;
procedure DBL_Str_2_Alpha;                  external DLLName index ID_DBL_STR_2_ALPHA;
function  DBL_SetExceptionHandler;          external DLLName index ID_DBL_SETEXCEPTIONHANDLER;
function  DBL_GetDatabaseName;              external DLLName index ID_DBL_GETDATABASENAME;
procedure DBL_CopyRec;                      external DLLName index ID_DBL_COPYREC;
function  DBL_CmpRec;                       external DLLName index ID_DBL_CMPREC;
function  DBL_SetMessageShowHandler;        external DLLName index ID_DBL_SETMESSAGESHOWHANDLER;
function  DBL_GetLastErrorCode;             external DLLName index ID_DBL_GETLASTERRORCODE;
procedure DBL_CheckLicenseFile;             external DLLName index ID_DBL_CHECKLICENSEFILE;
function  DBL_FieldDataOffset;              external DLLName index ID_DBL_FIELDDATAOFFSET;
procedure DBL_Str_2_Date;                   external DLLName index ID_DBL_STR_2_DATE;
procedure DBL_Date_2_Str;                   external DLLName index ID_DBL_DATE_2_STR;
procedure DBL_Str_2_Time;                   external DLLName index ID_DBL_STR_2_TIME;
procedure DBL_Time_2_Str;                   external DLLName index ID_DBL_TIME_2_STR;
procedure DBL_ReleaseAllObjects;            external DLLName index ID_DBL_RELEASEALLOBJECTS;
function  DBL_OpenTemporaryTable;           external DLLName index ID_DBL_OPENTEMPORARYTABLE;
function  DBL_FieldLen;                     external DLLName index ID_DBL_FIELDLEN;
procedure DBL_CreateTableBegin;             external DLLName index ID_DBL_CREATETABLEBEGIN;
procedure DBL_AddTableField;                external DLLName index ID_DBL_ADDTABLEFIELD;
procedure DBL_AddKey;                       external DLLName index ID_DBL_ADDKEY;
function  DBL_CreateTable;                  external DLLName index ID_DBL_CREATETABLE;
procedure DBL_CreateTableEnd;               external DLLName index ID_DBL_CREATETABLEEND;
function  DBL_DeleteTable;                  external DLLName index ID_DBL_DELETETABLE;
procedure DBL_SetNavisionPath;              external DLLName index ID_DBL_SETNAVISIONPATH;
procedure DBL_LoadLicenseFile;              external DLLName index ID_DBL_LOADLICENSEFILE;
procedure DBL_CryptPassword;                external DLLName index ID_DBL_CRYPTPASSWORD;
procedure DBL_DeleteRecs;                   external DLLName index ID_DBL_DELETERECS;
procedure DBL_BCD_2_Double;                 external DLLName index ID_DBL_BCD_2_DOUBLE;
procedure DBL_Double_2_BCD;                 external DLLName index ID_DBL_DOUBLE_2_BCD;
function  DBL_BCD_2_S32;                    external DLLName index ID_DBL_BCD_2_S32;
procedure DBL_S32_2_BCD;                    external DLLName index ID_DBL_S32_2_BCD;
function  DBL_BCD_IsZero;                   external DLLName index ID_DBL_BCD_ISZERO;
function  DBL_BCD_IsNegative;               external DLLName index ID_DBL_BCD_ISNEGATIVE;
function  DBL_BCD_IsPositive;               external DLLName index ID_DBL_BCD_ISPOSITIVE;
function  DBL_BCD_Div;                      external DLLName index ID_DBL_BCD_DIV;
function  DBL_BCD_Mul;                      external DLLName index ID_DBL_BCD_MUL;
function  DBL_BCD_Add;                      external DLLName index ID_DBL_BCD_ADD;
function  DBL_BCD_Sub;                      external DLLName index ID_DBL_BCD_SUB;
procedure DBL_BCD_Abs;                      external DLLName index ID_DBL_BCD_ABS;
procedure DBL_BCD_Neg;                      external DLLName index ID_DBL_BCD_NEG;
function  DBL_BCD_Power;                    external DLLName index ID_DBL_BCD_POWER;
function  DBL_BCD_Sgn;                      external DLLName index ID_DBL_BCD_SGN;
function  DBL_BCD_Cmp;                      external DLLName index ID_DBL_BCD_CMP;
procedure DBL_BCD_Trunc;                    external DLLName index ID_DBL_BCD_TRUNC;
procedure DBL_BCD_Round;                    external DLLName index ID_DBL_BCD_ROUND;
procedure DBL_BCD_RoundUnit;                external DLLName index ID_DBL_BCD_ROUNDUNIT;
function  DBL_BCD_Make;                     external DLLName index ID_DBL_BCD_MAKE;
procedure DBL_ConnectServerAndOpenDatabase; external DLLName index ID_DBL_CONNECTSERVERANDOPENDATABASE;
procedure DBL_Oem2AnsiBuff;                 external DLLName index ID_DBL_OEM2ANSIBUFF;
procedure DBL_Ansi2OemBuff;                 external DLLName index ID_DBL_ANSI2OEMBUFF;
procedure DBL_UseCodeUnitsPermissions;      external DLLName index ID_DBL_USECODEUNITSPERMISSIONS;
function  DBL_TableIsSame;                  external DLLName index ID_DBL_TABLEISSAME;
function  DBL_TableDup;                     external DLLName index ID_DBL_TABLEDUP;
function  DBL_DupRec;                       external DLLName index ID_DBL_DUPREC;
procedure DBL_SetView;                      external DLLName index ID_DBL_SETVIEW;
procedure DBL_GetView;                      external DLLName index ID_DBL_GETVIEW;
function  DBL_SetTransfer;                  external DLLName index ID_DBL_SETTRANSFER;
procedure DBL_DateFormula_2_Str;            external DLLName index ID_DBL_DATEFORMULA_2_STR;
procedure DBL_Str_2_DateFormula;            external DLLName index ID_DBL_STR_2_DATEFORMULA;
procedure DBL_S64_2_Str;                    external DLLName index ID_DBL_S64_2_STR;
procedure DBL_Str_2_S64;                    external DLLName index ID_DBL_STR_2_S64;
procedure DBL_S64_2_S32;                    external DLLName index ID_DBL_S64_2_S32;
procedure DBL_S32_2_S64;                    external DLLName index ID_DBL_S32_2_S64;
procedure DBL_Duration_2_Str;               external DLLName index ID_DBL_DURATION_2_STR;
procedure DBL_Str_2_Duration;               external DLLName index ID_DBL_STR_2_DURATION;
procedure DBL_Datetime_2_Str;               external DLLName index ID_DBL_DATETIME_2_STR;
procedure DBL_Str_2_Datetime;               external DLLName index ID_DBL_STR_2_DATETIME;
procedure DBL_DateTime_2_YMDHMST;           external DLLName index ID_DBL_DATETIME_2_YMDHMST;
procedure DBL_YMDHMST_2_DateTime;           external DLLName index ID_DBL_YMDHMST_2_DATETIME;
procedure DBL_GUID_2_Str;                   external DLLName index ID_DBL_GUID_2_STR;
procedure DBL_Str_2_GUID;                   external DLLName index ID_DBL_STR_2_GUID;

end.
