// ******************************************************************
// *  C/FRONT W1 3.60 - Delphi test application.
// *  Copyright  2003 Jan Hoek
// *  Release 0.90 (01/2003)
// ******************************************************************

program sample;

{$APPTYPE CONSOLE}

uses
  CFront,
  SysUtils;

const
  RECORDCOUNT = 500;

type
  TCSIDEKey = array[0..DBL_MaxFieldsPerKey - 1] of TDBL_S32;
  PCSIDEKey = ^TCSIDEKey;

var
  hTable: TDBL_HTABLE;
  hRec: TDBL_HREC;
  Key:  TCSIDEKey;
  pKey: PCSIDEKey;

begin
  DBL_Init;
  DBL_ConnectServer(PDBL_U8(PChar('localhost')), PDBL_U8(PChar('tcp')));
  WriteLn('Connected to server.');
  DBL_CheckLicenseFile(9110);
  DBL_OpenCompany(DBL_NextCompany(PDBL_U8(PChar(''))));
  WriteLn('Opened company "' + string(DBL_CompanyName) + '".');

  DBL_Allow(DBL_Err_TableNotFound);
  if DBL_OpenTable(@hTable, 36) then
  begin
    WriteLn('Opened table ' + IntToStr(36));
    WriteLn('Table is named ' + string(DBL_TableName(hTable)));
    WriteLn(string(DBL_FieldOptionStr(hTable, 1)));

    pKey := PCSIDEKey(DBL_NextKey(hTable, nil));
//    pKey := PCSIDEKey(DBL_NextKey(hTable, PDBL_S32(pKey)));
//    pKey := PCSIDEKey(DBL_NextKey(hTable, PDBL_S32(pKey)));
//    pKey := PCSIDEKey(DBL_NextKey(hTable, PDBL_S32(pKey)));

    Key := pKey^;
    WriteLn(string(DBL_FieldName(hTable, Key[0])));
    WriteLn(string(DBL_FieldName(hTable, Key[1])));
    WriteLn(key[2]);
    WriteLn(Key[3]);

    hRec := DBL_AllocRec(hTable);
    DBL_Allow(DBL_Err_RecordNotFound);
    if not DBL_FindRec(hTable, hRec, PDBL_U8(PChar('-'))) then;



    DBL_FreeRec(hRec);
    DBL_CloseTable(hTable);
  end;

  DBL_CloseCompany;
  DBL_DisconnectServer;



    {
{  
  verifyTables();
  verifyCreateTable();

  DBL_OpenTable(&hMainTable,50000);

  if (strcmp("Sample Table",(char*)DBL_TableName(hMainTable)) != 0)
  {
    printf("Sample Table does not exist\n");
    goto Error;
  }
{
  if (verifyTableSetup(hMainTable) != 0) goto Error;
  deleteAllRecords(hMainTable);
  if (createTestData(hMainTable) != 0) goto Error;
  if (verifyTestData(hMainTable) != 0) goto Error;
  if (verifyModifiedTestData(hMainTable) != 0) goto Error;
  if (verifyStringConversionFunctions() != 0) goto Error;
  if (verifySetFilter(hMainTable) != 0) goto Error;
  if (verifyKeyFunctions(hMainTable) != 0) goto Error;
  if (verifyBcdFunctions() != 0) goto Error;
  verifySumFunctions(hMainTable);



  if (ExceptionHandlerTest)
  {
    printf("Exception Handler test\n");
    DBL_OpenTable(&hMainTable,2000);
  }
{
Error:

  DBL_CloseTable(hMainTable);
  DBL_CloseCompany();

  if (NULL != ServerName)
    DBL_DisconnectServer();
  else
    DBL_CloseDatabase();

  DBL_Exit();
  printf("Database test ended\n");
}







//FieldDefinitionType fieldsstruct[] = {
//  { 10,  (DBL_U8*)"F1",  DBL_Type_S32,         4,  4  ,  NULL, 0 },                    /* Integer            */
//  { 20,  (DBL_U8*)"F2",  DBL_Type_STR,         30, 30+1, NULL, 0 },                    /* Text30             */
//  { 30,  (DBL_U8*)"F3",  DBL_Type_ALPHA,       10, 10+2, NULL, 0 },                    /* Code10             */
//  { 40,  (DBL_U8*)"F4",  DBL_Type_BCD,         12, 12,   NULL, 0 },                    /* Decimal            */
//  { 50,  (DBL_U8*)"F5",  DBL_Type_O32,         4,  4,    (DBL_U8*)"a,b,c,d,e", 0},     /* Option (a,b,c,d,e) */
//  { 60,  (DBL_U8*)"F6",  DBL_Type_BOOL,        4,  4,    NULL, 0 },                    /* Boolean            */
//  { 70,  (DBL_U8*)"F7",  DBL_Type_DATE,        4,  4,    NULL, 0 },                    /* Date               */
//  { 80,  (DBL_U8*)"F8",  DBL_Type_TIME,        4,  4,    NULL, 0 },                    /* Time               */
//  { 90,  (DBL_U8*)"F9",  DBL_Type_BLOB,        8,  8,    NULL, 0 },                    /* BLOB               */
//  { 100, (DBL_U8*)"F10", DBL_Type_DATEFORMULA, 32, 32,   NULL, 0 },                    /* DateFormula        */
//  { 110, (DBL_U8*)"F11", DBL_Type_S64,         8,  8,    NULL, 0 },                    /* S64                */
//  { 120, (DBL_U8*)"F12", DBL_Type_Duration,    8,  8,    NULL, 0 },                    /* Duration           */
//  { 130, (DBL_U8*)"F13", DBL_Type_Datetime,    8,  8,    NULL, 0 },                    /* Datetime           */
//  { 140, (DBL_U8*)"F14", DBL_Type_GUID,        16, 16,   NULL, 0 }                     /* GUID               */
//};

//void verifyCreateTable(void)
{
  DBL_HCREATE_TABLE hCT;
  DBL_S32     TableNo = 50000;
  DBL_U8     *TableName = (DBL_U8*)"Sample Table";
  DBL_S32     i;
  DBL_S32     NoOfFields = sizeof(fieldsstruct)/sizeof(fieldsstruct[0]);
  DBL_S32     Key[15];
  DBL_S32     SumIndexFields[15];


  printf("Verifying create table functions ..");

  /* Create table "Sample Table" */
  DBL_DeleteTable(TableNo);

  DBL_CreateTableBegin(&hCT, TableNo, TableName, 1);
  for(i = 0; i < NoOfFields; i++)
  {
      DBL_AddTableField(hCT, fieldsstruct[i].FieldNo,
                             fieldsstruct[i].FieldName,
                             fieldsstruct[i].FieldType,
                             fieldsstruct[i].FieldLen,
                             fieldsstruct[i].OptionStr,
                             fieldsstruct[i].FieldClass);
  }

{
  /* Create Key "F1", SumIndexKey "F4" */
  Key[0] = 10;
  Key[1] = 0;

  SumIndexFields[0] = 40;
  SumIndexFields[1] = 0;

  DBL_AddKey(hCT, Key, SumIndexFields);

  /* Create Key "F2, F3, F4, F5, F6", SumIndexKey "F4" */
  Key[0] = 20;
  Key[1] = 30;
  Key[2] = 40;
  Key[3] = 50;
  Key[4] = 60;
  Key[5] = 0;

  SumIndexFields[0] = 40;

  DBL_AddKey(hCT, Key, SumIndexFields);

  /* Create Key "F11, F10, F12, F13, F14", SumIndexKey "F4" */
  Key[0] = 110;
  Key[1] = 100;
  Key[2] = 120;
  Key[3] = 130;
  Key[4] = 140;
  Key[5] = 0;

  SumIndexFields[0] = 40;

  DBL_AddKey(hCT, Key, SumIndexFields);

  DBL_CreateTable(hCT);
  DBL_CreateTableEnd(hCT);

  /* Create table "Decimal Time Date"*/
  TableNo = 50001;
  TableName = (DBL_U8*)"Decimal Time Date";

  DBL_DeleteTable(TableNo);
  DBL_CreateTableBegin(&hCT, TableNo, TableName, 1);

  DBL_AddTableField(hCT, 10, (DBL_U8*)"Decimal", DBL_Type_BCD, 0, NULL, 0);
  DBL_AddTableField(hCT, 20, (DBL_U8*)"Date", DBL_Type_DATE, 0, NULL, 0);
  DBL_AddTableField(hCT, 30, (DBL_U8*)"Time", DBL_Type_TIME, 0, NULL, 0);

  DBL_CreateTable(hCT);
  DBL_CreateTableEnd(hCT);
  printf("OK\n");
}



//int verifyTableSetup(DBL_HTABLE hTable)
{
  DBL_S32  FieldNo = 0;
  DBL_S32 *Keys;
  DBL_U8  *ByteSet;
  DBL_S32  i = 0;

  printf("Verifying the table layout ..");

  if (DBL_FieldCount(hTable) != sizeof(fieldsstruct)/sizeof(FieldDefinitionType))
  {
    printf("Field count\nError !");
    return(-1);
  }

//  for(;;)
  {
    FieldNo = DBL_NextField(hTable,FieldNo);

    if(0 == FieldNo)
      break;

    if (FieldNo != fieldsstruct[i].FieldNo)
    {
      printf("Unknown fieldNo %d in table\nError !",FieldNo);
      return(-1);
    }

//    if (DBL_FieldClass(hTable, FieldNo) == DBL_Class_FlowField)
    {
      printf("FieldNo %d was a calculated field\nError !",FieldNo);
      return(-1);
    }

//    if (DBL_FieldClass(hTable, FieldNo) != DBL_Class_Normal)
    {
      printf("FieldNo %d was not a normal field\nError !",FieldNo);
      return(-1);
    }

//    if (DBL_FieldType(hTable,FieldNo) != fieldsstruct[i].FieldType)
    {
      printf("FieldType error FieldNo %d was %d, expected %d\nError !",FieldNo,DBL_FieldType(hTable,FieldNo),fieldsstruct[i].FieldType);
      return(-1);
    }

//    if (DBL_FieldSize(hTable,FieldNo) != fieldsstruct[i].FieldSize)
    {
      printf("FieldSize error FieldNo %d was %d, expected %d\nError !",FieldNo,DBL_FieldSize(hTable, FieldNo),fieldsstruct[i].FieldSize);
      return(-1);
    }

//    if (strcmp((char*)DBL_FieldName(hTable,FieldNo),(char*)fieldsstruct[i].FieldName))
    {
      printf("Fieldname error FieldNo %d was %s, expected %s\nError !", FieldNo,DBL_FieldName(hTable,FieldNo),fieldsstruct[i].FieldName);
      return(-1);
    }

//    if ((ByteSet = DBL_FieldOptionStr(hTable,FieldNo)) != NULL)
//      if ((5 == FieldNo) && (0 != strcmp((char*)ByteSet,"a,b,c,d,e")))
      {
  printf("ByteSet error: was (%s)  Expected (%s)\nError !",ByteSet,"a,b,c,d,e");
  return(-1);
      }
//    i++;
//  }

//  if (DBL_KeyCount(hTable) != 3)
  {
    printf("Key count\nError !");
    return(-1);
  }

//  Keys = DBL_NextKey(hTable,NULL);

//  if(Keys[0] != 10)
  {
    printf("Key field\nError !");
    return(-1);
  }

//  Keys = DBL_NextKey(hTable,Keys);

//  for(i=0; i<5; i++)
//    if(Keys[i] != fieldsstruct[i+1].FieldNo)
    {
      printf("Key field\nError !");
      return(-1);
    }

//  printf("OK\n");
//  return(0);
//}


//void deleteAllRecords(DBL_HTABLE hTable)
{
  printf("Deleting all records ..");
  DBL_BWT();
  DBL_DeleteRecs(hTable);
  DBL_EWT();
  printf("OK\n");
}


//DBL_S32 createTestData(DBL_HTABLE hTable)
{
  DBL_S32     i;
  DBL_HREC    hRec;
  char        s[100];

  printf("Creating test data ..");

  hRec = DBL_AllocRec(hTable);
  DBL_BWT();
  for (i = 0; i < RECORDCOUNT ;i++)
  {
    DBL_InitRec(hTable,hRec);
    sprintf(s,"This is record number %d",i);


    DBL_AssignField(hTable,hRec,10,DBL_FieldType(hTable,10),&i,DBL_FieldSize(hTable,10));
    DBL_AssignField(hTable,hRec,20,DBL_FieldType(hTable,20),s, strlen(s)+1);

    memset(s, i, sizeof(s));
    DBL_AssignField(hTable,hRec,90,DBL_FieldType(hTable,90),s,sizeof(s));

    DBL_Allow(DBL_Err_RecordExists);
    if (!DBL_InsertRec(hTable,hRec))
    {
      printf("Record %d was allready present in database\nError !!\n",i);
      DBL_AWT();
      DBL_FreeRec(hRec);
      return(-1);
    }
//  }
//  DBL_EWT();
//  DBL_FreeRec(hRec);
//  printf("OK\n");
//  return(0);
//}


//int verifyTestData(DBL_HTABLE hTable)
{
  DBL_S32   i;
  char      s[100];
  DBL_HREC  hRec;
  void     *FieldDataAddr;

  printf("Verifying test data ..");

  hRec = DBL_AllocRec(hTable);

  for (i = 0; i < RECORDCOUNT; i++ )
  {
    DBL_InitRec(hTable,hRec);
    DBL_AssignField(hTable,hRec,10,DBL_FieldType(hTable,10),&i,DBL_FieldSize(hTable,10));

    DBL_Allow(DBL_Err_RecordNotFound);
    if (!DBL_FindRec(hTable,hRec,(DBL_U8*)"="))
    {
      printf("Record %d not found\nError !!\n",i);
      DBL_FreeRec(hRec);
      return(-1);
    }

//    if (memcmp(DBL_GetFieldDataAddr(hTable,hRec,10),&i,sizeof(i)))
    {
      printf("Counter field differs %d\nError !!\n",i);
      DBL_FreeRec(hRec);
      return(-1);
    }

//    sprintf(s,"This is record number %d",i);
//    if (memcmp(DBL_GetFieldDataAddr(hTable,hRec,20),s,strlen(s)+1))
    {
      printf("Tekst field differs %s\nError !!\n",s);
      DBL_FreeRec(hRec);
      return(-1);
    }

//    memset(s, i, sizeof(s));
//    FieldDataAddr = DBL_GetFieldDataAddr(hTable,hRec,90);
//    if (memcmp(FieldDataAddr,s,sizeof(s)))
    {
      printf("BLOB field differs %d\nError !!\n",i);
      DBL_FreeRec(hRec);
      return(-1);
    }

//    if(sizeof(s) != DBL_GetFieldDataSize(hTable,90,FieldDataAddr))
    {
      printf("BLOB field datasize %d\nError !!\n",i);
      DBL_FreeRec(hRec);
      return(-1);
    }
//  }

//  DBL_FreeRec(hRec);
//  printf("OK\n");
//  return(0);
//}


//int verifyModifiedTestData(DBL_HTABLE hTable)
{
  DBL_S32     i;
  DBL_HREC    hRec;
  char        s[100];

  printf("Verifying modified test data ..");

  hRec = DBL_AllocRec(hTable);
  if (DBL_FieldNo(hTable,DBL_FieldName(hTable,10)) != 10)
  {
    printf("%s FieldName is not field no 10\n",DBL_FieldName(hTable,10));
    DBL_FreeRec(hRec);
    return(-1);
  }
{
  DBL_BWT();
  DBL_InitRec(hTable,hRec);
  i = 256;

  sprintf(s,"%d modified",i);
  DBL_AssignField(hTable,hRec,10,DBL_FieldType(hTable,10),&i,DBL_FieldSize(hTable,10));
  DBL_AssignField(hTable,hRec,20,DBL_FieldType(hTable,20),s, strlen(s)+1);

  DBL_Allow(DBL_Err_RecordNotFound);
  if (!DBL_ModifyRec(hTable,hRec))
  {
    printf("Record %d not found\nError !!\n",i);
    DBL_AWT();
    DBL_FreeRec(hRec);
    return(-1);

  DBL_EWT();

  DBL_Allow(DBL_Err_RecordNotFound);
  if (!DBL_FindRec(hTable,hRec,(DBL_U8*)"="))
  {
    printf("Record %d not found\nError !!\n",i);
    DBL_FreeRec(hRec);
    return(-1);


  if (memcmp(DBL_GetFieldDataAddr(hTable,hRec,10),&i,sizeof(i)))
  {
    printf("Integer field (F1) differs %d\nError !!\n",i);
    DBL_FreeRec(hRec);
    return(-1);


  if (memcmp(DBL_GetFieldDataAddr(hTable,hRec,20),s,strlen(s)+1))
  {
    printf("Tekst field (F2) differs %s\nError !!\n",s);
    DBL_FreeRec(hRec);
    return(-1);


  DBL_FreeRec(hRec);
  printf("OK\n");
  return(0);
}


//int verifyStringConversionFunctions(void)
{
  DBL_U8        resStr[50];
  DBL_HTABLE    hTable;
  DBL_HREC      hRec;
  DBL_TIME     *pTime,        cTime;
  DBL_DATE     *pDate,        cDate;
  DBL_BCD      *pBcd,         cBcd;
  DBL_S32       cS32;
  DBL_U8       *pDateFormula, cDateFormula[50];
  DBL_S64      *pS64,         cS64;
  DBL_Duration *pDuration,    cDurationInt, cDurationText;
  DBL_Datetime *pDatetime,    cDatetime;
  DBL_GUID     *pGuid,        cGuid;


  printf("Testing string to/from type conversion  ..");

  /* Test table 50001 */
  DBL_OpenTable(&hTable,50001);
  hRec = DBL_AllocRec(hTable);
  DBL_InitRec(hTable,hRec);

  DBL_Str_2_BCD(&cBcd, (DBL_U8*)"3141592,65");
  DBL_Str_2_Date(&cDate, (DBL_U8*)"08-05-98");
  DBL_Str_2_Time(&cTime, (DBL_U8*)"3:14:15");

  DBL_AssignField(hTable,hRec,10,DBL_FieldType(hTable,10),&cBcd,DBL_FieldSize(hTable,10));
  DBL_AssignField(hTable,hRec,20,DBL_FieldType(hTable,20),&cDate,DBL_FieldSize(hTable,20));
  DBL_AssignField(hTable,hRec,30,DBL_FieldType(hTable,30),&cTime,DBL_FieldSize(hTable,30));
  DBL_BWT();
  DBL_InsertRec(hTable,hRec);
  DBL_EWT();

  DBL_InitRec(hTable,hRec);
  if (!DBL_FindRec(hTable,hRec,(DBL_U8*)"-"))
  {
    printf("Record not found\nError !!\n");
    goto Error;


  pBcd = (DBL_BCD*)DBL_GetFieldDataAddr(hTable,hRec,10);

  DBL_BCD_2_Str(resStr,sizeof(resStr),pBcd);
  DBL_Str_2_BCD(&cBcd,resStr);

  if(memcmp(pBcd, &cBcd, sizeof(DBL_BCD)))
  {
    printf("BCD conversion \nError !!\n");
    goto Error;


  pDate = (DBL_DATE*)DBL_GetFieldDataAddr(hTable,hRec,20);

  DBL_Date_2_Str(resStr,sizeof(resStr),*pDate);
  DBL_Str_2_Date(&cDate,resStr);

  if(memcmp(pDate, &cDate, sizeof(DBL_DATE)))
  {
    printf("DATE conversion \nError !!\n");
    goto Error;


  pTime = (DBL_TIME*)DBL_GetFieldDataAddr(hTable,hRec,30);

  DBL_Time_2_Str(resStr,sizeof(resStr),*pTime);
  DBL_Str_2_Time(&cTime,resStr);

  if(memcmp(pTime, &cTime, sizeof(DBL_TIME)))
  {
    printf("TIME conversion \nError !!\n");
    goto Error;


  DBL_FreeRec(hRec);
  DBL_CloseTable(hTable);

  /* Test table 50000*/
  DBL_OpenTable(&hTable,50000);
  hRec = DBL_AllocRec(hTable);
  DBL_InitRec(hTable,hRec);

  DBL_Str_2_DateFormula(cDateFormula, sizeof(cDateFormula), (DBL_U8*)"1D+2W-2Q");
  DBL_Str_2_S64(&cS64, (DBL_U8*)"9999999999");
  DBL_Str_2_Duration(&cDurationInt, (DBL_U8*)"120");
  //DBL_Str_2_Duration(&cDurationText, (DBL_U8*)"120 hrs");
  DBL_Str_2_Datetime(&cDatetime, (DBL_U8*)"01-01-2003 12:24:59,123");
  DBL_Str_2_GUID(&cGuid, (DBL_U8*)"{96DD345D-1858-48a3-BDED-F3E830E8BFEB}
  {
  cS32 = 501;
  DBL_AssignField(hTable,hRec,10,DBL_FieldType(hTable,10), &cS32, DBL_FieldSize(hTable,10));
  DBL_AssignField(hTable,hRec,100,DBL_FieldType(hTable,100),cDateFormula,DBL_FieldSize(hTable,100));
  DBL_AssignField(hTable,hRec,110,DBL_FieldType(hTable,110),&cS64,DBL_FieldSize(hTable,110));
  DBL_AssignField(hTable,hRec,120,DBL_FieldType(hTable,120),&cDurationInt,DBL_FieldSize(hTable,120));
  DBL_AssignField(hTable,hRec,130,DBL_FieldType(hTable,130),&cDatetime,DBL_FieldSize(hTable,130));
  DBL_AssignField(hTable,hRec,140,DBL_FieldType(hTable,140),&cGuid,DBL_FieldSize(hTable,140));

  DBL_BWT();
  DBL_InsertRec(hTable,hRec);
  DBL_EWT();

  DBL_InitRec(hTable,hRec);
  if (!DBL_FindRec(hTable,hRec,(DBL_U8*)"+"))
  {
    printf("Record not found\nError !!\n");
    goto Error;


  pDateFormula = (DBL_U8*)DBL_GetFieldDataAddr(hTable,hRec,100);

  DBL_DateFormula_2_Str(resStr, sizeof(resStr), pDateFormula);
  DBL_Str_2_DateFormula(cDateFormula, sizeof(cDateFormula), resStr);

  if(memcmp(pDateFormula, cDateFormula, sizeof(32)))
  {
    printf("DateFormula conversion \nEror !!\n");
    goto Error;


  pS64 = (DBL_S64*)DBL_GetFieldDataAddr(hTable,hRec,110);

  DBL_S64_2_Str(resStr, sizeof(resStr), pS64);
  DBL_Str_2_S64(&cS64, resStr);

  if(memcmp(pS64, &cS64, sizeof(DBL_S64)))
  {
    printf("BigInteger conversion \nError !!\n");
    goto Error;

    pDuration = (DBL_Duration*)DBL_GetFieldDataAddr(hTable,hRec, 120);

  DBL_Duration_2_Str(resStr, sizeof(resStr), pDuration);
  DBL_Str_2_Duration(&cDurationText, resStr);

  if(memcmp(pDuration, &cDurationText, sizeof(DBL_Duration)))
  {
    printf("Duration conversion \nError !!\n");
    goto Error;


  pDatetime = (DBL_Datetime*)DBL_GetFieldDataAddr(hTable,hRec, 130);

  DBL_Datetime_2_Str(resStr, sizeof(resStr), pDatetime);
  DBL_Str_2_Datetime(&cDatetime, resStr);

  if(memcmp(pDatetime, &cDatetime, sizeof(DBL_Datetime)))
  {
    printf("Datetime conversion \nError !!\n");
    goto Error;


  pGuid = (DBL_GUID*)DBL_GetFieldDataAddr(hTable,hRec,140);

  DBL_GUID_2_Str(resStr, sizeof(resStr), pGuid);
  DBL_Str_2_GUID(&cGuid, resStr);

  if(memcmp(pGuid, &cGuid, sizeof(DBL_GUID)))
  {
    printf("GUID conversion \nError !!\n");
    goto Error;


  DBL_FreeRec(hRec);
  DBL_CloseTable(hTable);
  printf("OK\n");
  return(0);


Error:
  DBL_FreeRec(hRec);
  DBL_CloseTable(hTable);
  return(-1);



int verifySetFilter(DBL_HTABLE hTable)
{
  char    s[80];
  DBL_U16 MinValue;
  DBL_U16 MaxValue;

  printf("Testing filter functions ..");

  DBL_SetFilter(hTable,10,(DBL_U8*)">100&<200","",NULL);

  if (DBL_RecCount(hTable) != 99)
  {
    printf("Error\n");
    DBL_SetFilter(hTable,10,(DBL_U8*)"",NULL);
    return(-1);


  DBL_GetFilter(hTable,10,(DBL_U8*)s,sizeof(s)-1);
  if (strcmp(s,">100&<200") != 0)
  {
    printf("Error\n");
    DBL_SetFilter(hTable,10,(DBL_U8*)"",NULL);
    return(-1);


  MinValue = 100;
  MaxValue = 200;
  DBL_SetRange(hTable,10,&MinValue,&MaxValue);
  MinValue = 0;
  MaxValue = 0;
  DBL_GetRange(hTable, 10,&MinValue, &MaxValue);

  if ((MinValue != 100) || (MaxValue != 200))
  {
    printf("Error\n");
    DBL_SetFilter(hTable,10,(DBL_U8*)"",NULL);
    return(-1);


  DBL_SetFilter(hTable,10,(DBL_U8*)"",NULL);
  printf("OK\n");
  return(0);
}


//int verifyKeyFunctions(DBL_HTABLE hTable)
{
  DBL_S32  i;
  DBL_S32 *Key;
  DBL_S32 *SumFields;

  printf("Testing key functions ..");

  Key = DBL_NextKey(hTable,NULL);

  if (Key == NULL)
  {
    printf("Error\n");
    return(-1);
  }

// if (Key[0] != 10)
  {
    printf("Error\n");
    return(-1);
  }

//  DBL_Allow(DBL_Err_KeyNotFound);
//  if (!DBL_SetCurrentKey(hTable,Key))
  {
    printf("Error\n");
    return(-1);
  }

//  Key = DBL_GetCurrentKey(hTable);

//  if (Key == NULL)
  {
    printf("Error\n");
    return(-1);
  }

//  if (Key[0] != 10)
  {
    printf("Error\n");
    return(-1);
  }


//  SumFields = DBL_KeySumFields(hTable,Key);
//  if (SumFields == NULL)
  {
    printf("Error\n");
    return(-1);
  }

//  if (SumFields[0] != 40)
  {
    printf("Error\n");
    return(-1);


  Key = DBL_NextKey(hTable,Key);

  for(i=0; i<5; i++)
    if(Key[i] != fieldsstruct[i+1].FieldNo)
    {
      printf("Key field\nError !");
      return(-1);


  printf("OK\n");
  return(0);
}


//void verifySumFunctions(DBL_HTABLE hTable)
{
  DBL_S32   *Key;
  DBL_S32   *SumFields;
  DBL_HREC  hRec;

  printf("Testing sum functions ..");

  hRec = DBL_AllocRec(hTable);
  Key = DBL_NextKey(hTable,NULL);
  SumFields = DBL_KeySumFields(hTable,Key);
  DBL_CalcSums(hTable,hRec,SumFields);
  DBL_FreeRec(hRec);
  printf("OK\n");
}

// nt verifyBcdFunctions()
{
  DBL_BCD b1, b2, b3, b4;
  DBL_S32 s1, s2;
  double  d1, d2;

  printf("Testing bcd functions ..");


  d1 = 12.56789;
  DBL_Double_2_BCD(&b1, d1);
  DBL_Double_2_BCD(&b2, d1);
  DBL_BCD_Round(&b1, 2);
  DBL_BCD_Trunc(&b2, 2);
  DBL_BCD_2_Double(&d1, &b1);
  DBL_BCD_2_Double(&d2, &b2);

  if ((d1 != 12.57) || (d2 != 12.56))
  {
    printf("Bcd functions \nError !");
    return(-1);


  d1 = 12.56789;
  DBL_Double_2_BCD(&b1, d1);
  DBL_BCD_RoundUnit(&b1, DBL_BCD_Make(&b2, DBL_Make_Bcd_10), DBL_BCD_Up);
  DBL_BCD_2_Double(&d1, &b1);

  if (d1 != 20.0)
  {
    printf("Bcd functions \nError !");
    return(-1);


  d1 = 12.56789;
  DBL_Double_2_BCD(&b1, d1);
  DBL_BCD_RoundUnit(&b1, DBL_BCD_Make(&b2, DBL_Make_Bcd_10), DBL_BCD_Near);
  DBL_BCD_2_Double(&d1, &b1);

  if (d1 != 10.0)
  {
    printf("Bcd functions \nError !");
    return(-1);


  d1 = 12.56789;
  DBL_Double_2_BCD(&b1, d1);
  DBL_BCD_RoundUnit(&b1, DBL_BCD_Make(&b2, DBL_Make_Bcd_10), DBL_BCD_Down);
  DBL_BCD_2_Double(&d1, &b1);

  if (d1 != 10.0)
  {
    printf("Bcd functions \nError !");
    return(-1);


  s1 = 31415;
  DBL_S32_2_BCD(&b1, s1);
  s2 = DBL_BCD_2_S32(&b1);

  if (s1 != s2)
  {
    printf("Bcd functions \nError !");
    return(-1);
  }

//  DBL_BCD_Make(&b1, DBL_Make_Bcd_0);

//  if (!DBL_BCD_IsZero(&b1) || DBL_BCD_IsNegative(&b1) || DBL_BCD_IsPositive(&b1) || (0 != DBL_BCD_Sgn(&b1)))
  {
    printf("Bcd functions \nError !");
    return(-1);
  }

//  DBL_BCD_Make(&b1, DBL_Make_Bcd_1);

//  if (DBL_BCD_IsZero(&b1) || DBL_BCD_IsNegative(&b1) || !DBL_BCD_IsPositive(&b1) || (1 != DBL_BCD_Sgn(&b1)))
  {
    printf("Bcd functions \nError !");
    return(-1);
  }

//  DBL_BCD_Neg(&b1);

//  if (DBL_BCD_IsZero(&b1) || !DBL_BCD_IsNegative(&b1) || DBL_BCD_IsPositive(&b1) || (-1 != DBL_BCD_Sgn(&b1)))
  {
    printf("Bcd functions \nError !");
    return(-1);
  }

//  DBL_BCD_Abs(&b1);

//  if (!DBL_BCD_IsPositive(&b1))
  {
    printf("Bcd functions \nError !");
    return(-1);
  }

//  DBL_BCD_Make(&b1, DBL_Make_Bcd_2);
//  DBL_BCD_Make(&b2, DBL_Make_Bcd_10);

//  if ( (-1 != DBL_BCD_Cmp(&b1, &b2)) || (1 != DBL_BCD_Cmp(&b2, &b1)) || (0 != DBL_BCD_Cmp(&b1, &b1)) )
  {
    printf("Bcd functions \nError !");
    return(-1);
  }

//  if (DBL_BCD_Cmp(DBL_BCD_Power(&b1,&b2), DBL_BCD_Make(&b4, DBL_Make_Bcd_1024)))
  {
    printf("Bcd functions \nError !");
    return(-1);


  b3 = *DBL_BCD_Div(&b2, DBL_BCD_Make(&b1, DBL_Make_Bcd_2));
  s1 = 5;
  DBL_S32_2_BCD(&b4, s1);
  if (DBL_BCD_Cmp(&b3, &b4))
  {
    printf("Bcd functions \nError !");
    return(-1);


  b3 = *DBL_BCD_Mul(DBL_BCD_Make(&b2, DBL_Make_Bcd_10), &b1);
  s1 = 20;
  DBL_S32_2_BCD(&b4, s1);
  if (DBL_BCD_Cmp(&b3, &b4))
  {
    printf("Bcd functions \nError !");
    return(-1);


  b3 = *DBL_BCD_Sub(DBL_BCD_Make(&b2, DBL_Make_Bcd_10), &b1);
  s1 = 8;
  DBL_S32_2_BCD(&b4, s1);
  if (DBL_BCD_Cmp(&b3, &b4))
  {
    printf("Bcd functions \nError !");
    return(-1);


  b3 = *DBL_BCD_Add(DBL_BCD_Make(&b2, DBL_Make_Bcd_10), &b1);
  s1 = 12;
  DBL_S32_2_BCD(&b4, s1);
  if (DBL_BCD_Cmp(&b3, &b4))
  {
    printf("Bcd functions \nError !");
    return(-1);


  printf("OK\n");
  return(0);
}

end.
